# PDMats.jl

Uniform interface for positive definite matrices of various structures.

[![CI](https://github.com/JuliaStats/PDMats.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaStats/PDMats.jl/actions/workflows/ci.yml)
[![Coverage Status](https://img.shields.io/coveralls/JuliaStats/PDMats.jl.svg)](https://coveralls.io/r/JuliaStats/PDMats.jl?branch=master)
[![code style: runic](https://img.shields.io/badge/code_style-%E1%9A%B1%E1%9A%A2%E1%9A%BE%E1%9B%81%E1%9A%B2-black)](https://github.com/fredrikekre/Runic.jl)

--------------

Positive definite matrices are widely used in machine learning and probabilistic modeling, especially in applications related to graph analysis and Gaussian models. It is not uncommon that positive definite matrices used in practice have special structures (e.g. diagonal), which can be exploited to accelerate computation.

*PDMats.jl* supports efficient computation on positive definite matrices of various structures. In particular, it provides uniform interfaces to use positive definite matrices of various structures for writing generic algorithms, while ensuring that the most efficient implementation is used in actual computation.

----------------


## Positive definite matrix types

This package defines an abstract type `AbstractPDMat{T<:Real}` as the base type for positive definite matrices with different internal representations.

Elemenent types are in princple all Real types, but in practice this is limited by the support for floating point types in Base.LinAlg.Cholesky.
  - `Float64`     Fully supported from Julia 0.3.
  - `Float32`     Fully supported from Julia 0.4.2. Full, diagonal and scale matrix types are supported in Julia 0.3 or higher.
  - `Float16`     Promoted to `Float32` for full, diagonal and scale matrix. Currently unsupported for sparse matrix.
  - `BigFloat`    Supported in Julia 0.4 for full, diagonal and scale matrix. Currently unsupported for sparse matrix.

* `PDMat`: full covariance matrix, defined as

```julia
struct PDMat{T<:Real,S<:AbstractMatrix{T},C<:Cholesky{T}} <: AbstractPDMat{T}
    mat::S                      # input matrix
    chol::C                     # Cholesky factorization of mat
end

# Constructors

PDMat(mat, chol)    # with both the input matrix and a Cholesky factorization

PDMat(mat)          # with the input matrix, of type Matrix or Symmetric
                    # Remarks: the Cholesky factorization will be computed
                    # upon construction.

PDMat(chol)         # with the Cholesky factorization
                    # Remarks: the full matrix will be computed upon
                    # construction.
```


* `PDiagMat`: diagonal matrix, defined as

```julia
struct PDiagMat{T<:Real,V<:AbstractVector{T}} <: AbstractPDMat{T}
    diag::V                     # the vector of diagonal elements
end

# Constructors

PDiagMat(v)         # with the vector of diagonal elements
```


* `ScalMat`: uniform scaling matrix, as `v * eye(d)`, defined as

```julia
struct ScalMat{T<:Real} <: AbstractPDMat{T}
    dim::Int         # matrix dimension
    value::T         # diagonal value (shared by all diagonal elements)
end


# Constructors

ScalMat(d, v)        # with dimension d and diagonal value v
```


* `PDSparseMat`: sparse covariance matrix, defined as

```julia
struct PDSparseMat{T<:Real,S<:AbstractSparseMatrix} <: AbstractPDMat{T}
    mat::SparseMatrixCSC           # input matrix
    chol::CholTypeSparse           # Cholesky factorization of mat
end

# Constructors

PDSparseMat(mat, chol)    # with both the input matrix and a Cholesky factorization

PDSparseMat(mat)          # with the sparse input matrix, of type SparseMatrixCSC
                          # Remarks: the Cholesky factorization will be computed
                          # upon construction.

PDSparseMat(chol)         # with the Cholesky factorization
                          # Remarks: the sparse matrix 'mat' will be computed upon
                          # construction.
```


## Common interface

All subtypes of `AbstractPDMat` share the same API, *i.e.* with the same set of methods to operate on their instances. These methods are introduced below, where `a` is an instance of a subtype of `AbstractPDMat` to represent a positive definite matrix, `x` be a column vector or a matrix with `size(x,1) == size(a, 1) == size(a, 2)`, and `c` be a positive real value.

```julia
size(a)     # return the size of `a`.

size(a, i)  # return the i-th dimension of `a`.

ndims(a)    # the number of dimensions, which is always 2.

eltype(a)   # the element type

Matrix(a)   # return a copy of the matrix in full form.

diag(a)     # return a vector of diagonal elements.

inv(a)      # inverse of `a`, of a proper subtype of `AbstractPDMat`.
            # Note: when `a` is an instance of either `PDMat`, `PDiagMat`,
            # and `ScalMat`, `inv(a)` is of the same type of `a`.
            # This needs not be required for customized subtypes -- the
            # inverse does not always has the same pattern as `a`.

eigmax(a)   # maximum eigenvalue of `a`.

eigmin(a)   # minimum eigenvalue of `a`.

logdet(a)   # log-determinant of `a`, computed in a numerically stable way.

a * x       # multiple `a` with `x` (forward transform)

a \ x       # multiply `inv(a)` with `x` (backward transform).
            # The internal implementation may not explicitly instantiate
            # the inverse of `a`.

a * c       # scale `a` by a positive scale `c`.
            # The result is in general of the same type of `a`.

c * a       # equivalent to a * c.

a + b       # add two positive definite matrices

pdadd(a, b, c)      # add `a` with `b * c`, where both `a` and `b` are
                    # instances of `AbstractPDMat`.

pdadd(m, a)         # add `a` to a dense matrix `m` of the same size.

pdadd(m, a, c)      # add `a * c` to a dense matrix `m` of the same size.

pdadd!(m, a)        # add `a` to a dense matrix `m` of the same size inplace.

pdadd!(m, a, c)     # add `a * c` to a dense matrix `m` of the same size,
                    # inplace.

pdadd!(r, m, a)     # add `a` to a dense matrix `m` of the same size, and write
                    # the result to `r`.

pdadd!(r, m, a, c)  # add `a * c` to a dense matrix `m` of the same size, and
                    # write the result to `r`.

quad(a, x)          # compute x' * a * x when `x` is a vector.
                    # perform such computation in a column-wise fashion, when
                    # `x` is a matrix, and return a vector of length `n`,
                    # where `n` is the number of columns in `x`.

quad!(r, a, x)      # compute x' * a * x in a column-wise fashion, and write
                    # the results to `r`.

invquad(a, x)       # compute x' * inv(a) * x when `x` is a vector.
                    # perform such computation in a column-wise fashion, when
                    # `x` is a matrix, and return a vector of length `n`.

invquad!(r, a, x)   # compute x' * inv(a) * x in a column-wise fashion, and
                    # write the results to `r`.

X_A_Xt(a, x)        # compute `x * a * x'` for a matrix `x`.

Xt_A_X(a, x)        # compute `x' * a * x` for a matrix `x`.

X_invA_Xt(a, x)     # compute `x * inv(a) * x'` for a matrix `x`.

Xt_invA_X(a, x)     # compute `x' * inv(a) * x` for a matrix `x`.

whiten(a, x)        # whitening transform defined by `a`. `x` can be a vector or a matrix.
                    #
                    # Note: If the covariance of `x` is `a`, then the
                    # covariance of the transformed result is an identity
                    # matrix.

whiten!(a, x)       # whitening transform inplace, directly updating `x`.

whiten!(r, a, x)    # write the transformed result to `r`.

invwhiten(a, x)     # whitening transform defined by `inv(a)`. `x` can be a vector or a matrix.
                    #
                    # Note: If the precision of `x` is `a`, then the
                    # covariance of the transformed result is an identity matrix.

invwhiten!(a, x)    # whitening transform inplace, directly updating `x`.

invwhiten!(r, a, x) # write the transformed result to `r`.

unwhiten(a, x)      # inverse of whitening transform with `a`.
                    # `x` can be a vector or a matrix.
                    #
                    # Note: If the covariance of `x` is an identity matrix,
                    # then the covariance of the transformed result is `a`.
                    # Note: the un-whitening transform is useful for
                    # generating Gaussian samples.

unwhiten!(a, x)     # un-whitening transform inplace, updating `x`.

unwhiten!(r, a, x)  # write the transformed result to `r`.

invunwhiten(a, x)     # inverse of whitening transform defined by `inv(a)`.
                      # `x` can be a vector or a matrix.
                      #
                      # Note: If the covariance of `x` is an identity matrix,
                      # then the precision of the transformed result is `a`.
                      # Note: the un-whitening transform is useful for
                      # generating Gaussian samples.

invunwhiten!(a, x)    # un-whitening transform inplace, updating `x`.

invunwhiten!(r, a, x) # write the transformed result to `r`.
```

### Fallbacks for `AbstractArray`s
For ease of composability, some of these functions have generic fallbacks defined that work on `AbstractArray`s.
These fallbacks may not be as fast as the methods specializaed for `AbstractPDMat`s, but they let you more easily swap out types.
While in theory all of them can be defined, at present only the following subset has:

 - `whiten`, `whiten!`
 - `unwhiten`, `unwhiten!`
 - `quad`, `quad!`
 - `invquad`, `invquad!`

PRs to implement more generic fallbacks are welcome.

### Fallbacks for `LinearAlgebra.Cholesky`

For Cholesky decompositions of type `Cholesky` the following functions are defined as well:

 - `dim`
 - `whiten`, `whiten!`
 - `unwhiten`, `unwhiten!`
 - `quad`, `quad!`
 - `invquad`, `invquad!`
 - `X_A_Xt`, `Xt_A_X`, `X_invA_Xt`, `Xt_invA_X`

## Define Customized Subtypes

In some situation, it is useful to define a customized subtype of `AbstractPDMat` to capture positive definite matrices with special structures. For this purpose, one has to define a subset of methods (as listed below), and other methods will be automatically provided.

```julia
# Let `M` be the name of the subtype, then the following methods need
# to be implemented for `M`:

Matrix(a::M)    # return a copy of the matrix in full form, of type
                # `Matrix{eltype(M)}`.

diag(a::M)      # return the vector of diagonal elements, of type
                # `Vector{eltype(M)}`.

pdadd!(m, a, c)     # add `a * c` to a dense matrix `m` of the same size
                    # inplace.

* (a::M, c::Real)        # return a scaled version of `a`.

* (a::M, x::DenseVecOrMat)  # transform `x`, i.e. compute `a * x`.

\ (a::M, x::DenseVecOrMat)  # inverse transform `x`, i.e. compute `inv(a) * x`.

inv(a::M)       # compute the inverse of `a`.

logdet(a::M)    # compute the log-determinant of `a`.

eigmax(a::M)    # compute the maximum eigenvalue of `a`.

eigmin(a::M)    # compute the minimum eigenvalue of `a`.

whiten!(r::DenseVecOrMat, a::M, x::DenseVecOrMat)  # whitening transform,
                                                   # write result to `r`.

unwhiten!(r::DenseVecOrMat, a::M, x::DenseVecOrMat)  # un-whitening transform,
                                                     # write result to `r`.

quad(a::M, x::DenseVector)      # compute `x' * a * x`

quad!(r::AbstractArray, a::M, x::DenseMatrix)   # compute `x' * a * x` in
                                                # a column-wise manner

invquad(a::M, x::DenseVector)   # compute `x' * inv(a) * x`

invquad!(r::AbstractArray, a::M, x::DenseMatrix) # compute `x' * inv(a) * x`
                                                 # in a column-wise manner

X_A_Xt(a::M, x::DenseMatrix)        # compute `x * a * x'`

Xt_A_X(a::M, x::DenseMatrix)        # compute `x' * a * x`

X_invA_Xt(a::M, x::DenseMatrix)     # compute `x * inv(a) * x'`

Xt_invA_X(a::M, x::DenseMatrix)     # compute `x' * inv(a) * x`
```

using PDMats
using LinearAlgebra
using Test

# Before loading StatsBase
@test Base.get_extension(PDMats, :StatsBaseExt) === nothing

# After loading StatsBase
using StatsBase
@test Base.get_extension(PDMats, :StatsBaseExt) isa Module

@testset "cor2cov" begin
    for T in (Float64, Float32)
        σ = rand(T, 3)
        for S in (Float64, Float32)
            for C in (ScalMat(3, S(1)), PDiagMat(ones(S, 3)), PDMat((x -> cov2cor(x * x' + I))(randn(S, 3, 3))))
                D = cor2cov(C, σ)
                @test D isa AbstractPDMat{promote_type(T, S)}
                @test size(D) == (3, 3)
                @test Matrix(D) ≈ cor2cov(Matrix(C), σ)
            end
        end
    end
end

@testset "cov2cor" begin
    for S in (Float64, Float32)
        for D in (ScalMat(3, rand(S)), PDiagMat(rand(S, 3)), PDMat((x -> x * x' + I)(randn(S, 3, 3))))
            for T in (Float64, Float32)
                σ = sqrt.(T.(diag(D)))
                C = cov2cor(D, σ)
                @test C isa AbstractPDMat{promote_type(T, S)}
                @test size(C) == (3, 3)
                @test Matrix(C) ≈ cov2cor(Matrix(D), σ) rtol = sqrt(eps(T === Float64 && S === Float64 ? Float64 : Float32))

                C = cov2cor(D)
                @test C isa AbstractPDMat{S}
                @test size(C) == (3, 3)
                @test Matrix(C) ≈ cov2cor(Matrix(D))
            end
        end
    end
end

module PDMats

using LinearAlgebra, SparseArrays, SuiteSparse

import Base: +, *, \, /, ==, convert, inv, Matrix, kron

export
    # Types
    AbstractPDMat,
    PDMat,
    PDSparseMat,
    PDiagMat,
    ScalMat,

    # Functions
    dim,
    whiten,
    whiten!,
    invwhiten,
    invwhiten!,
    unwhiten,
    unwhiten!,
    invunwhiten,
    invunwhiten!,
    pdadd,
    pdadd!,
    quad,
    quad!,
    invquad,
    invquad!,
    X_A_Xt,
    Xt_A_X,
    X_invA_Xt,
    Xt_invA_X


"""
The base type for positive definite matrices.
"""
abstract type AbstractPDMat{T <: Real} <: AbstractMatrix{T} end

const HAVE_CHOLMOD = isdefined(SuiteSparse, :CHOLMOD)

# source files

include("utils.jl")
include("chol.jl")

include("pdmat.jl")

if HAVE_CHOLMOD
    include("pdsparsemat.jl")
end

include("pdiagmat.jl")
include("scalmat.jl")

include("generics.jl")
include("addition.jl")
include("congruence.jl")

include("deprecates.jl")

end # module

# addition of positive definite matrices

using PDMats


# New AbstractPDMat type for the tests below
# Supports only functions needed in the tests below
struct ScalMat3D{T <: Real} <: AbstractPDMat{T}
    value::T
end
Base.Matrix(a::ScalMat3D) = Matrix(Diagonal(fill(a.value, 3)))
Base.size(::ScalMat3D) = (3, 3)
# Not generally correct
Base.:*(a::ScalMat3D, c::Real) = ScalMat3D(a.value * c)
Base.getindex(a::ScalMat3D, i::Int, j::Int) = i == j ? a.value : zero(a.value)

@testset "addition" begin
    for T in (Float64, Float32)
        printstyled("Testing addition with eltype = $T\n"; color = :blue)
        M = convert(Array{T, 2}, [4.0 -2.0 -1.0; -2.0 5.0 -1.0; -1.0 -1.0 6.0])
        V = convert(Array{T, 1}, [1.5, 2.5, 2.0])
        local X = convert(T, 2.0)

        pm1 = PDMat(M)
        pm2 = PDiagMat(V)
        pm3 = PDiagMat(sparse(V))
        pm4 = ScalMat(3, X)
        pm5 = PDSparseMat(sparse(M))
        pm6 = ScalMat3D(X)

        pmats = Any[pm1, pm2, pm3, pm4, pm5, pm6]

        for p1 in pmats, p2 in pmats
            pr = p1 + p2
            @test size(pr) == size(p1)
            @test Matrix(pr) ≈ Matrix(p1) + Matrix(p2)

            if p1 isa ScalMat3D
                @test_broken pdadd(p1, p2, convert(T, 1.5))
            else
                pr = pdadd(p1, p2, convert(T, 1.5))
                @test size(pr) == size(p1)
                @test Matrix(pr) ≈ Matrix(p1) + Matrix(p2) * convert(T, 1.5)
            end
        end

        for p1 in pmats
            if p1 isa ScalMat3D
                @test_broken p1 + X * I
            else
                pr = p1 + X * I
                @test size(pr) == size(p1)
                @test Matrix(pr) ≈ Matrix(p1) + X * I
            end
        end
    end
end

using Test, PDMats

@testset "AbstractMatrix fallback functionality" begin
    C = Cmat = [4.0 -2.0 -1.0; -2.0 5.0 -1.0; -1.0 -1.0 6.0]

    test_pdmat(
        C, Cmat;
        verbose = 2,             # the level to display intermediate steps
        cmat_eq = true,          # require Cmat and Matrix(C) to be exactly equal
        t_diag = false,          # whether to test diag method
        t_cholesky = false,      # whether to test cholesky method
        t_scale = false,         # whether to test scaling
        t_add = false,           # whether to test pdadd
        t_det = false,           # whether to test det method
        t_logdet = false,        # whether to test logdet method
        t_eig = false,           # whether to test eigmax and eigmin
        t_mul = false,           # whether to test multiplication
        t_div = false,           # whether to test division
        t_quad = true,           # whether to test quad & invquad
        t_triprod = false,       # whether to test X_A_Xt, Xt_A_X, X_invA_Xt, and Xt_invA_X
        t_whiten = true          # whether to test whiten and unwhiten
    )

end

include("testutils.jl")
tests = ["pdmtypes", "abstracttypes", "addition", "congruence", "generics", "kron", "chol", "specialarrays", "sqrt", "ad", "typeparams", "ext/statsbase"]
println("Running tests ...")

for t in tests
    println("* $t ")
    include("$t.jl")
end

# test operators with pd matrix types
using LinearAlgebra, SparseArrays, PDMats
using Test

@testset "scalar multiplication" begin
    printstyled("Testing scalar multiplication\n"; color = :blue)
    pm1 = PDMat(Matrix(1.0I, 3, 3))
    pm2 = PDiagMat(ones(3))
    pm3 = ScalMat(3, 1)

    pm1a = PDMat(Matrix(3.0I, 3, 3))
    pm2a = PDiagMat(3.0 .* ones(3))
    pm3a = ScalMat(3, 3)

    pmats = Any[pm1, pm2, pm3]
    pmatsa = Any[pm1a, pm2a, pm3a]

    for i in 1:length(pmats)
        @test Matrix(3.0 * pmats[i]) == Matrix(pmatsa[i])
        @test Matrix(pmats[i] * 3.0) == Matrix(pmatsa[i])
        @test Matrix(3 * pmats[i]) == Matrix(pmatsa[i])
        @test Matrix(pmats[i] * 3) == Matrix(pmatsa[i])
    end
end

# issue #121
@test isposdef(PDMat([1.0 0.0; 0.0 1.0]))
@test isposdef(PDiagMat([1.0, 1.0]))
@test isposdef(ScalMat(2, 3.0))

@testset "ldiv!(A, b)" begin
    printstyled("Testing ldiv!(A, b)\n"; color = :blue)
    for A in (PDMat([4.0 2.0; 2.0 3.0]), PDiagMat([4.0, 3.0]), ScalMat(2, 4.0) #=PDSparseMat(sparse([4.0 2.0; 2.0 3.0]))=#) # CHOLMOD.Factor is not supported by ldiv!
        b = [1.0, 2.0]
        x = copy(b)
        ldiv!(A, x)
        @test isapprox(A * x, b)
        B = [1.0 2.0; 3.0 4.0]
        X = copy(B)
        ldiv!(A, X)
        @test isapprox(A * X, B)
    end
end

# Congruent transforms X_A_Xt, Xt_A_X, X_invA_Xt, Xt_invA_X for guaranteed PD return values

for f in (:X_A_Xt, :Xt_A_X)
    @eval begin
        function $(f)(A::ScalMat, B::ScalMat)
            @check_argdims A.dim == B.dim
            return ScalMat(A.dim, abs2(B.value) * A.value)
        end
        $(f)(A::PDiagMat, B::PDiagMat) = PDiagMat(abs2.(B.diag) .* A.diag)
        $(f)(A::PDiagMat, B::ScalMat) = PDiagMat(abs2(B.value) .* A.diag)
        function $(f)(A::ScalMat, B::PDiagMat)
            @check_argdims A.dim == size(B, 1)
            return PDiagMat(abs2.(B.diag) .* A.value)
        end
        function $(f)(A::PDMat, B::ScalMat)
            @check_argdims B.dim == size(A, 1)
            b2 = abs2(B.value)
            mat = b2 * A.mat
            uplo = A.chol.uplo
            if uplo === 'U'
                factors = A.chol.factors * B.value'
            else
                factors = B.value * A.chol.factors
            end
            chol = Cholesky(factors, uplo, A.chol.info)
            return PDMat(mat, chol)
        end
        function $(f)(A::PDMat, B::PDiagMat)
            b = B.diag
            mat = A.mat .* (b .* b')
            uplo = A.chol.uplo
            if uplo === 'U'
                factors = A.chol.factors .* b'
            else
                factors = b .* A.chol.factors
            end
            chol = Cholesky(factors, uplo, A.chol.info)
            return PDMat(mat, chol)
        end
    end
end

for f in (:X_invA_Xt, :Xt_invA_X)
    @eval begin
        $(f)(A::ScalMat, B::ScalMat) = B * (A \ B)
        $(f)(A::PDiagMat, B::PDiagMat) = PDiagMat(B.diag .* (A.diag .\ B.diag))
        $(f)(A::PDiagMat, B::ScalMat) = PDiagMat(B.value .* (A.diag .\ B.value))
        function $(f)(A::ScalMat, B::PDiagMat)
            @check_argdims A.dim == size(B, 1)
            return PDiagMat(B.diag .* (A.value .\ B.diag))
        end
    end
end

# Accessing a.L directly might involve an extra copy();
# instead, always use the stored Cholesky factor
# Using `a.factors` instead of `a.L` or `a.U` avoids one
# additional `LowerTriangular` or `UpperTriangular` wrapper and
# leads to better performance
function chol_lower(a::Cholesky)
    return a.uplo === 'L' ? LowerTriangular(a.factors) : LowerTriangular(a.factors')
end
function chol_upper(a::Cholesky)
    return a.uplo === 'U' ? UpperTriangular(a.factors) : UpperTriangular(a.factors')
end

# For a dense Matrix, the following allows us to avoid the Adjoint wrapper:
chol_lower(a::Matrix) = cholesky(Symmetric(a, :L)).L
# NOTE: Formally, the line above should use Hermitian() instead of Symmetric(),
# but this currently has an AutoDiff issue in Zygote.jl, and PDMat is
# type-restricted to be Real, so they are equivalent.
chol_upper(a::Matrix) = cholesky(Symmetric(a, :U)).U

if HAVE_CHOLMOD
    CholTypeSparse{T} = SuiteSparse.CHOLMOD.Factor{T}

    # Take into account pivoting!
    chol_lower(cf::CholTypeSparse) = cf.PtL
    chol_upper(cf::CholTypeSparse) = cf.UP
end

# Interface for `Cholesky`

dim(A::Cholesky) = LinearAlgebra.checksquare(A)

# whiten
whiten(A::Cholesky, x::AbstractVecOrMat) = chol_lower(A) \ x
whiten!(A::Cholesky, x::AbstractVecOrMat) = ldiv!(chol_lower(A), x)
invwhiten(A::Cholesky, x::AbstractVecOrMat) = chol_upper(A) * x
invwhiten!(A::Cholesky, x::AbstractVecOrMat) = lmul!(chol_upper(A), x)

# unwhiten
unwhiten(A::Cholesky, x::AbstractVecOrMat) = chol_lower(A) * x
unwhiten!(A::Cholesky, x::AbstractVecOrMat) = lmul!(chol_lower(A), x)
invunwhiten(A::Cholesky, x::AbstractVecOrMat) = chol_upper(A) \ x
invunwhiten!(A::Cholesky, x::AbstractVecOrMat) = ldiv!(chol_upper(A), x)

# 3-argument whiten/unwhiten
for T in (:AbstractVector, :AbstractMatrix)
    @eval begin
        whiten!(r::$T, A::Cholesky, x::$T) = whiten!(A, copyto!(r, x))
        invwhiten!(r::$T, A::Cholesky, x::$T) = invwhiten!(A, copyto!(r, x))
        unwhiten!(r::$T, A::Cholesky, x::$T) = unwhiten!(A, copyto!(r, x))
        invunwhiten!(r::$T, A::Cholesky, x::$T) = invunwhiten!(A, copyto!(r, x))
    end
end

# quad
function quad(A::Cholesky, x::AbstractVector)
    @check_argdims size(A, 1) == length(x)
    return sum(abs2, chol_upper(A) * x)
end
function quad(A::Cholesky, X::AbstractMatrix)
    @check_argdims size(A, 1) == size(X, 1)
    Z = chol_upper(A) * X
    return vec(sum(abs2, Z; dims = 1))
end
function quad!(r::AbstractArray, A::Cholesky, X::AbstractMatrix)
    @check_argdims eachindex(r) == axes(X, 2)
    @check_argdims size(A, 1) == size(X, 1)
    aU = chol_upper(A)
    z = similar(r, size(A, 1)) # buffer to save allocations
    @inbounds for i in axes(X, 2)
        mul!(z, aU, view(X, :, i))
        r[i] = sum(abs2, z)
    end
    return r
end

# invquad
function invquad(A::Cholesky, x::AbstractVector)
    @check_argdims size(A, 1) == size(x, 1)
    return sum(abs2, chol_lower(A) \ x)
end
function invquad(A::Cholesky, X::AbstractMatrix)
    @check_argdims size(A, 1) == size(X, 1)
    Z = chol_lower(A) \ X
    return vec(sum(abs2, Z; dims = 1))
end
function invquad!(r::AbstractArray, A::Cholesky, X::AbstractMatrix)
    @check_argdims eachindex(r) == axes(X, 2)
    @check_argdims size(A, 1) == size(X, 1)
    aL = chol_lower(A)
    z = similar(r, size(A, 1)) # buffer to save allocations
    @inbounds for i in axes(X, 2)
        copyto!(z, view(X, :, i))
        ldiv!(aL, z)
        r[i] = sum(abs2, z)
    end
    return r
end

# tri products

function X_A_Xt(A::Cholesky, X::AbstractMatrix{<:Real})
    @check_argdims size(A, 1) == size(X, 2)
    Z = X * chol_lower(A)
    return Symmetric(Z * transpose(Z))
end

function Xt_A_X(A::Cholesky, X::AbstractMatrix{<:Real})
    @check_argdims size(A, 1) == size(X, 1)
    Z = chol_upper(A) * X
    return Symmetric(transpose(Z) * Z)
end

function X_invA_Xt(A::Cholesky, X::AbstractMatrix{<:Real})
    @check_argdims size(A, 1) == size(X, 2)
    Z = X / chol_upper(A)
    return Symmetric(Z * transpose(Z))
end

function Xt_invA_X(A::Cholesky, X::AbstractMatrix{<:Real})
    @check_argdims size(A, 1) == size(X, 1)
    Z = chol_lower(A) \ X
    return Symmetric(transpose(Z) * Z)
end

"""
Scaling matrix.
"""
struct ScalMat{T <: Real} <: AbstractPDMat{T}
    dim::Int
    value::T
end

### Conversion
Base.convert(::Type{ScalMat{T}}, a::ScalMat{T}) where {T <: Real} = a
Base.convert(::Type{ScalMat{T}}, a::ScalMat) where {T <: Real} = ScalMat{T}(a.dim, T(a.value))
Base.convert(::Type{AbstractPDMat{T}}, a::ScalMat) where {T <: Real} = convert(ScalMat{T}, a)

### Basics

Base.size(a::ScalMat) = (a.dim, a.dim)
Base.Matrix{T}(a::ScalMat) where {T} = Matrix{T}(T(a.value) * I, a.dim, a.dim)
LinearAlgebra.diag(a::ScalMat) = fill(a.value, a.dim)
LinearAlgebra.cholesky(a::ScalMat) = Cholesky(Diagonal(fill(sqrt(a.value), a.dim)), 'U', 0)

### Inheriting from AbstractMatrix

function Base.getindex(a::ScalMat, i::Integer)
    ncol, nrow = fldmod1(i, a.dim)
    return ncol == nrow ? a.value : zero(eltype(a))
end
Base.getindex(a::ScalMat{T}, i::Integer, j::Integer) where {T} = i == j ? a.value : zero(T)

### Arithmetics

function pdadd!(r::Matrix, a::Matrix, b::ScalMat, c)
    @check_argdims size(r) == size(a) == size(b)
    if r === a
        _adddiag!(r, b.value * c)
    else
        _adddiag!(copyto!(r, a), b.value * c)
    end
    return r
end

*(a::ScalMat, c::Real) = ScalMat(a.dim, a.value * c)
/(a::ScalMat, c::Real) = ScalMat(a.dim, a.value / c)
function *(a::ScalMat, x::AbstractVector)
    @check_argdims a.dim == length(x)
    return a.value * x
end
function *(a::ScalMat, x::AbstractMatrix)
    @check_argdims a.dim == size(x, 1)
    return a.value * x
end
function \(a::ScalMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return x / a.value
end
function /(x::AbstractVecOrMat, a::ScalMat)
    @check_argdims a.dim == size(x, 2)
    return x / a.value
end
Base.kron(A::ScalMat, B::ScalMat) = ScalMat(A.dim * B.dim, A.value * B.value)

### Algebra

Base.inv(a::ScalMat) = ScalMat(a.dim, inv(a.value))
LinearAlgebra.det(a::ScalMat) = a.value^a.dim
LinearAlgebra.logdet(a::ScalMat) = a.dim * log(a.value)
LinearAlgebra.eigmax(a::ScalMat) = a.value
LinearAlgebra.eigmin(a::ScalMat) = a.value
LinearAlgebra.sqrt(a::ScalMat) = ScalMat(a.dim, sqrt(a.value))

function LinearAlgebra.ldiv!(A::ScalMat, B::AbstractVecOrMat)
    @check_argdims A.dim == size(B, 1)
    return ldiv!(A.value, B)
end


### whiten and unwhiten

function whiten!(r::AbstractVecOrMat, a::ScalMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    return ldiv!(r, sqrt(a.value), x)
end
invwhiten!(r::AbstractVecOrMat, a::ScalMat, x::AbstractVecOrMat) = unwhiten!(r, a, x)

function unwhiten!(r::AbstractVecOrMat, a::ScalMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    return mul!(r, x, sqrt(a.value))
end
invunwhiten!(r::AbstractVecOrMat, a::ScalMat, x::AbstractVecOrMat) = whiten!(r, a, x)

function whiten(a::ScalMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return x / sqrt(a.value)
end
invwhiten(a::ScalMat, x::AbstractVecOrMat) = unwhiten(a, x)
function unwhiten(a::ScalMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return sqrt(a.value) * x
end
invunwhiten(a::ScalMat, x::AbstractVecOrMat) = whiten(a, x)

### quadratic forms

function quad(a::ScalMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    if x isa AbstractVector
        return sum(abs2, x) * a.value
    else
        # map(Base.Fix1(quad, a), eachcol(x)) or similar alternatives
        # do NOT return a `SVector` for inputs `x::SMatrix`.
        wsq = let w = a.value
            x -> w * abs2(x)
        end
        return vec(sum(wsq, x; dims = 1))
    end
end

function quad!(r::AbstractArray, a::ScalMat, x::AbstractMatrix)
    @check_argdims eachindex(r) == axes(x, 2)
    @check_argdims a.dim == size(x, 1)
    @inbounds for i in axes(x, 2)
        r[i] = quad(a, view(x, :, i))
    end
    return r
end

function invquad(a::ScalMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    if x isa AbstractVector
        return sum(abs2, x) / a.value
    else
        # map(Base.Fix1(invquad, a), eachcol(x)) or similar alternatives
        # do NOT return a `SVector` for inputs `x::SMatrix`.
        wsq = let w = a.value
            x -> abs2(x) / w
        end
        return vec(sum(wsq, x; dims = 1))
    end
end

function invquad!(r::AbstractArray, a::ScalMat, x::AbstractMatrix)
    @check_argdims eachindex(r) == axes(x, 2)
    @check_argdims a.dim == size(x, 1)
    @inbounds for i in axes(x, 2)
        r[i] = invquad(a, view(x, :, i))
    end
    return r
end


### tri products

function X_A_Xt(a::ScalMat, x::AbstractMatrix{<:Real})
    @check_argdims LinearAlgebra.checksquare(a) == size(x, 2)
    return Symmetric(a.value * (x * transpose(x)))
end

function Xt_A_X(a::ScalMat, x::AbstractMatrix{<:Real})
    @check_argdims LinearAlgebra.checksquare(a) == size(x, 1)
    return Symmetric(a.value * (transpose(x) * x))
end

function X_invA_Xt(a::ScalMat, x::AbstractMatrix{<:Real})
    @check_argdims LinearAlgebra.checksquare(a) == size(x, 2)
    return Symmetric((x * transpose(x)) / a.value)
end

function Xt_invA_X(a::ScalMat, x::AbstractMatrix{<:Real})
    @check_argdims LinearAlgebra.checksquare(a) == size(x, 1)
    return Symmetric((transpose(x) * x) / a.value)
end

# Specializations for `x::Matrix` with reduced allocations
function X_A_Xt(a::ScalMat, x::Matrix{<:Real})
    @check_argdims LinearAlgebra.checksquare(a) == size(x, 2)
    return Symmetric(lmul!(a.value, x * transpose(x)))
end

function Xt_A_X(a::ScalMat, x::Matrix{<:Real})
    @check_argdims LinearAlgebra.checksquare(a) == size(x, 1)
    return Symmetric(lmul!(a.value, transpose(x) * x))
end

function X_invA_Xt(a::ScalMat, x::Matrix{<:Real})
    @check_argdims LinearAlgebra.checksquare(a) == size(x, 2)
    return Symmetric(rdiv!(x * transpose(x), a.value))
end

function Xt_invA_X(a::ScalMat, x::Matrix{<:Real})
    @check_argdims LinearAlgebra.checksquare(a) == size(x, 1)
    return Symmetric(rdiv!(transpose(x) * x, a.value))
end

# Utilities for testing
#
#       One can use the facilities provided here to simplify the testing of
#       the implementation of a subtype of AbstractPDMat
#

using PDMats, SuiteSparse, Test, Random

Random.seed!(10)

const HAVE_CHOLMOD = isdefined(SuiteSparse, :CHOLMOD)
const PDMatType = HAVE_CHOLMOD ? Union{PDMat, PDSparseMat, PDiagMat} : Union{PDMat, PDiagMat}

## driver function
function test_pdmat(
        C, Cmat::Matrix;
        verbose::Int = 2,             # the level to display intermediate steps
        cmat_eq::Bool = false,        # require Cmat and Matrix(C) to be exactly equal
        t_diag::Bool = true,          # whether to test diag method
        t_cholesky::Bool = true,      # whether to test cholesky method
        t_scale::Bool = true,         # whether to test scaling
        t_add::Bool = true,           # whether to test pdadd
        t_det::Bool = true,           # whether to test det method
        t_logdet::Bool = true,        # whether to test logdet method
        t_eig::Bool = true,           # whether to test eigmax and eigmin
        t_mul::Bool = true,           # whether to test multiplication
        t_div::Bool = true,           # whether to test division
        t_quad::Bool = true,          # whether to test quad & invquad
        t_triprod::Bool = true,       # whether to test X_A_Xt, Xt_A_X, X_invA_Xt, and Xt_invA_X
        t_whiten::Bool = true         # whether to test whiten and unwhiten
    )

    d = size(Cmat, 1)
    verbose >= 1 && printstyled("Testing $(typeof(C)) of size ($d, $d)\n", color = :blue)

    pdtest_basics(C, Cmat, d, verbose)
    pdtest_cmat(C, Cmat, cmat_eq, verbose)

    t_diag && pdtest_diag(C, Cmat, cmat_eq, verbose)
    isa(C, PDMatType) && t_cholesky && pdtest_cholesky(C, Cmat, cmat_eq, verbose)
    t_scale && pdtest_scale(C, Cmat, verbose)
    t_add && pdtest_add(C, Cmat, verbose)
    t_det && pdtest_det(C, Cmat, verbose)
    t_logdet && pdtest_logdet(C, Cmat, verbose)

    t_eig && pdtest_eig(C, Cmat, verbose)
    Imat = inv(Cmat)

    n = 5
    X = rand(eltype(C), d, n) .- convert(eltype(C), 0.5)

    t_mul && pdtest_mul(C, Cmat, X, verbose)
    t_div && pdtest_div(C, Imat, X, verbose)
    t_quad && pdtest_quad(C, Cmat, Imat, X, verbose)
    t_triprod && pdtest_triprod(C, Cmat, Imat, X, verbose)

    t_whiten && pdtest_whiten(C, Cmat, verbose)

    return verbose >= 2 && println()
end


## core testing functions

_pdt(vb::Int, s) = (vb >= 2 && printstyled("    .. testing $s\n", color = :green))


function pdtest_basics(C, Cmat::Matrix, d::Int, verbose::Int)
    _pdt(verbose, "dim")
    @test @test_deprecated(dim(C)) == d

    _pdt(verbose, "size")
    @test size(C) == (d, d)
    @test size(C, 1) == d
    @test size(C, 2) == d
    @test size(C, 3) == 1

    _pdt(verbose, "ndims")
    @test ndims(C) == 2

    _pdt(verbose, "length")
    @test length(C) == d * d

    _pdt(verbose, "eltype")
    @test eltype(C) == eltype(Cmat)
    #    @test eltype(typeof(C)) == eltype(typeof(Cmat))

    _pdt(verbose, "index")
    @test all(C[i] == Cmat[i] for i in 1:(d^2))
    @test all(C[i, j] == Cmat[i, j] for j in 1:d, i in 1:d)

    _pdt(verbose, "isposdef")
    @test isposdef(C)

    _pdt(verbose, "ishermitian")
    @test ishermitian(C)

    _pdt(verbose, "AbstractPDMat")
    M = AbstractPDMat(C)
    @test M isa AbstractPDMat
    if C isa AbstractPDMat
        @test M === C
    end

    _pdt(verbose, "Matrix")
    M = Matrix(C)
    @test M isa Matrix
    return @test M == Cmat
end


function pdtest_cmat(C, Cmat::Matrix, cmat_eq::Bool, verbose::Int)
    _pdt(verbose, "full")
    return if cmat_eq
        @test Matrix(C) == Cmat
    else
        @test Matrix(C) ≈ Cmat
    end
end


function pdtest_diag(C, Cmat::Matrix, cmat_eq::Bool, verbose::Int)
    _pdt(verbose, "diag")
    return if cmat_eq
        @test diag(C) == diag(Cmat)
    else
        @test diag(C) ≈ diag(Cmat)
    end
end

function pdtest_cholesky(C::Union{PDMat, PDiagMat, ScalMat}, Cmat::Matrix, cmat_eq::Bool, verbose::Int)
    _pdt(verbose, "cholesky")
    if cmat_eq
        @test cholesky(C).U == cholesky(Cmat).U
    else
        @test cholesky(C).U ≈ cholesky(Cmat).U
    end
    # regression test: https://github.com/JuliaStats/PDMats.jl/pull/182
    return if C isa Union{PDiagMat, ScalMat}
        size_of_sqrt_diag = C.dim * sizeof(float(eltype(C)))
        # allow some overhead for wrapper types
        max_allocations = max(1.05 * size_of_sqrt_diag, 128 + size_of_sqrt_diag)
        @test (@allocated cholesky(C)) <= max_allocations
    end
end

if HAVE_CHOLMOD
    function pdtest_cholesky(C::PDSparseMat, Cmat::Matrix, cmat_eq::Bool, verbose::Int)
        _pdt(verbose, "cholesky")
        # We special case PDSparseMat because we can't perform equality checks on
        # `SuiteSparse.CHOLMOD.Factor`s and `SuiteSparse.CHOLMOD.FactorComponent`s
        return @test diag(cholesky(C)) ≈ diag(cholesky(Cmat).U)
        # NOTE: `==` also doesn't work because `diag(cholesky(C))` will return `Vector{Float64}`
        # even if the inputs are `Float32`s.
    end
end

function pdtest_scale(C, Cmat::Matrix, verbose::Int)
    _pdt(verbose, "scale")
    @test Matrix(C * convert(eltype(C), 2)) ≈ Cmat * convert(eltype(C), 2)
    return @test Matrix(convert(eltype(C), 2) * C) ≈ convert(eltype(C), 2) * Cmat
end


function pdtest_add(C, Cmat::Matrix, verbose::Int)
    M = rand(eltype(C), size(Cmat))
    _pdt(verbose, "add")
    @test C + M ≈ Cmat + M
    @test M + C ≈ M + Cmat

    _pdt(verbose, "add_scal")
    @test pdadd(M, C, convert(eltype(C), 2)) ≈ M + Cmat * convert(eltype(C), 2)

    _pdt(verbose, "add_scal!")
    R = M + Cmat * convert(eltype(C), 2)
    Mr = pdadd!(M, C, convert(eltype(C), 2))
    @test Mr === M
    return @test Mr ≈ R
end

function pdtest_det(C, Cmat::Matrix, verbose::Int)
    _pdt(verbose, "det")
    @test det(C) ≈ det(Cmat)

    # generic fallback in LinearAlgebra performs LU decomposition
    return if C isa Union{PDMat, PDiagMat, ScalMat}
        @test iszero(@allocated det(C))
    end
end

function pdtest_logdet(C, Cmat::Matrix, verbose::Int)
    _pdt(verbose, "logdet")
    @test logdet(C) ≈ logdet(Cmat)

    # generic fallback in LinearAlgebra performs LU decomposition
    return if C isa Union{PDMat, PDiagMat, ScalMat}
        @test iszero(@allocated logdet(C))
    end
end


function pdtest_eig(C, Cmat::Matrix, verbose::Int)
    _pdt(verbose, "eigmax")
    @test eigmax(C) ≈ eigmax(Cmat)

    _pdt(verbose, "eigmin")
    return @test eigmin(C) ≈ eigmin(Cmat)
end


function pdtest_mul(C, Cmat::Matrix, verbose::Int)
    n = 5
    X = rand(eltype(C), size(C, 1), n)
    return pdtest_mul(C, Cmat, X, verbose)
end


function pdtest_mul(C, Cmat::Matrix, X::Matrix, verbose::Int)
    _pdt(verbose, "multiply")
    d, n = size(X)
    @assert d == size(C, 1) == size(C, 2)
    @assert size(Cmat) == size(C)
    @test C * X ≈ Cmat * X

    y = similar(C * X, d)
    ymat = similar(Cmat * X, d)
    for i in 1:n
        xi = vec(copy(X[:, i]))
        @test C * xi ≈ Cmat * xi

        mul!(y, C, xi)
        mul!(ymat, Cmat, xi)
        @test y ≈ ymat
    end

    # Dimension mismatches
    @test_throws DimensionMismatch C * rand(d + 1)
    return @test_throws DimensionMismatch C * rand(d + 1, n)
end


function pdtest_div(C, Imat::Matrix, X::Matrix, verbose::Int)
    _pdt(verbose, "divide")
    d, n = size(X)
    @assert d == size(C, 1) == size(C, 2)
    @assert size(Imat) == size(C)
    @test C \ X ≈ Imat * X
    @test Matrix(X') / C ≈ (C \ X)'

    for i in 1:n
        xi = vec(copy(X[:, i]))
        @test C \ xi ≈ Imat * xi
        @test Matrix(xi') / C ≈ (C \ xi)'
    end


    # Dimension mismatches
    @test_throws DimensionMismatch C \ rand(d + 1)
    @test_throws DimensionMismatch C \ rand(d + 1, n)
    @test_throws DimensionMismatch rand(1, d + 1) / C
    @test_throws DimensionMismatch rand(n, d + 1) / C
    return nothing
end


function pdtest_quad(C, Cmat::Matrix, Imat::Matrix, X::Matrix, verbose::Int)
    n = size(X, 2)

    _pdt(verbose, "quad")
    r_quad = zeros(eltype(C), n)
    for i in 1:n
        xi = vec(X[:, i])
        r_quad[i] = dot(xi, Cmat * xi)
        @test quad(C, xi) ≈ r_quad[i]
        @test quad(C, view(X, :, i)) ≈ r_quad[i]
    end
    @test quad(C, X) ≈ r_quad
    r = similar(r_quad)
    @test quad!(r, C, X) === r
    @test r ≈ r_quad

    _pdt(verbose, "invquad")
    r_invquad = zeros(eltype(C), n)
    for i in 1:n
        xi = vec(X[:, i])
        r_invquad[i] = dot(xi, Imat * xi)
        @test invquad(C, xi) ≈ r_invquad[i]
        @test invquad(C, view(X, :, i)) ≈ r_invquad[i]
    end
    @test invquad(C, X) ≈ r_invquad
    r = similar(r_invquad)
    @test invquad!(r, C, X) === r
    return @test r ≈ r_invquad
end


function pdtest_triprod(C, Cmat::Matrix, Imat::Matrix, X::Matrix, verbose::Int)
    d, n = size(X)
    @assert d == size(C, 1) == size(C, 2)
    Xt = copy(transpose(X))

    _pdt(verbose, "X_A_Xt")
    M = X_A_Xt(C, Xt)
    @test M ≈ Xt * Cmat * X
    @test issymmetric(M)
    @test_throws DimensionMismatch X_A_Xt(C, rand(n, d + 1))

    _pdt(verbose, "Xt_A_X")
    M = Xt_A_X(C, X)
    @test M ≈ Xt * Cmat * X
    @test issymmetric(M)
    @test_throws DimensionMismatch Xt_A_X(C, rand(d + 1, n))

    _pdt(verbose, "X_invA_Xt")
    M = X_invA_Xt(C, Xt)
    @test M ≈ Xt * Imat * X
    @test issymmetric(M)
    @test_throws DimensionMismatch X_invA_Xt(C, rand(n, d + 1))

    _pdt(verbose, "Xt_invA_X")
    M = Xt_invA_X(C, X)
    @test M ≈ Xt * Imat * X
    @test issymmetric(M)
    return @test_throws DimensionMismatch Xt_invA_X(C, rand(d + 1, n))
end


function pdtest_whiten(C, Cmat::Matrix, verbose::Int)
    # generate a matrix Y such that Y * Y' = C
    Y = similar(Cmat, float(eltype(C)))
    Q = qr(randn!(similar(Cmat, float(eltype(C))))).Q
    mul!(Y, PDMats.chol_lower(Cmat), Q')
    @test Y * Y' ≈ Cmat

    # generate a matrix A such that A * A' ≈ inv(C)
    A = similar(Cmat, float(eltype(C)))
    Q = qr(randn!(similar(Cmat, float(eltype(C))))).Q
    ldiv!(A, PDMats.chol_upper(Cmat), Matrix(Q)')
    @test (A * A') * Cmat ≈ I

    d = size(C, 1)

    _pdt(verbose, "whiten")
    Z = whiten(C, Y)
    @test Z * Z' ≈ Matrix{eltype(C)}(I, d, d)
    for i in 1:d
        @test whiten(C, Y[:, i]) ≈ Z[:, i]
    end

    _pdt(verbose, "whiten!")
    Z2 = copy(Y)
    whiten!(C, Z2)
    @test Z2 ≈ Z
    Z2 = copy(Y)
    whiten!(Z2, C, Y)
    @test Z2 ≈ Z

    _pdt(verbose, "invwhiten")
    B = invwhiten(C, A)
    @test B * B' ≈ Matrix{eltype(C)}(I, d, d)
    for i in 1:d
        @test invwhiten(C, A[:, i]) ≈ B[:, i]
    end

    _pdt(verbose, "invwhiten!")
    B2 = copy(A)
    invwhiten!(C, B2)
    @test B2 ≈ B
    B2 = copy(A)
    invwhiten!(B2, C, A)
    @test B2 ≈ B

    _pdt(verbose, "unwhiten")
    X = unwhiten(C, Z)
    @test X * X' ≈ Cmat
    for i in 1:d
        @test unwhiten(C, Z[:, i]) ≈ X[:, i]
    end

    _pdt(verbose, "unwhiten!")
    X2 = copy(Z)
    unwhiten!(C, X2)
    @test X2 ≈ X
    X2 = copy(Z)
    unwhiten!(X2, C, Z)
    @test X2 ≈ X

    _pdt(verbose, "invunwhiten")
    D = invunwhiten(C, B)
    @test (D * D') * Cmat ≈ Matrix{eltype(C)}(I, d, d)
    for i in 1:d
        @test invunwhiten(C, B[:, i]) ≈ D[:, i]
    end

    _pdt(verbose, "invunwhiten!")
    D2 = copy(B)
    invunwhiten!(C, D2)
    @test D2 ≈ D
    D2 = copy(B)
    invunwhiten!(D2, C, B)
    @test D2 ≈ D

    _pdt(verbose, "whiten-unwhiten")
    @test unwhiten(C, whiten(C, Matrix{eltype(C)}(I, d, d))) ≈ Matrix{eltype(C)}(I, d, d)
    @test whiten(C, unwhiten(C, Matrix{eltype(C)}(I, d, d))) ≈ Matrix{eltype(C)}(I, d, d)

    _pdt(verbose, "invwhiten-invunwhiten")
    @test invunwhiten(C, invwhiten(C, Matrix{eltype(C)}(I, d, d))) ≈ Matrix{eltype(C)}(I, d, d)
    @test invwhiten(C, invunwhiten(C, Matrix{eltype(C)}(I, d, d))) ≈ Matrix{eltype(C)}(I, d, d)

    return nothing
end


# testing functions for kron and sqrt

_randPDMat(T, n) = (X = randn(T, n, n); PDMat(X * X' + LinearAlgebra.I))
_randPDiagMat(T, n) = PDiagMat(rand(T, n))
_randScalMat(T, n) = ScalMat(n, rand(T))
_randPDSparseMat(T, n) = (X = T.(sprand(n, 1, 0.5)); PDSparseMat(X * X' + LinearAlgebra.I))

function _rand(::Type{PDMat}, T, n, uplo::Char)
    X = _randPDMat(T, n)
    cholX = cholesky(X)
    cholX.uplo === uplo && return X
    (; factors, info) = cholX
    return PDMat(Cholesky(Matrix(factors'), uplo, info))
end
_rand(::Type{PDiagMat}, T, n, _) = _randPDiagMat(T, n)
_rand(::Type{ScalMat}, T, n, _) = _randScalMat(T, n)

function _pd_compare(A::AbstractPDMat, B::AbstractPDMat)
    @test size(A) == size(B)
    @test Matrix(A) ≈ Matrix(B)
    @test cholesky(A).L ≈ cholesky(B).L
    return @test cholesky(A).U ≈ cholesky(B).U
end

# between pdmat and pdmat

+(a::PDMat, b::AbstractPDMat) = PDMat(a.mat + Matrix(b))
+(a::PDiagMat, b::AbstractPDMat) = PDMat(_adddiag!(Matrix(b), a.diag, true))
+(a::ScalMat, b::AbstractPDMat) = PDMat(_adddiag!(Matrix(b), a.value))
if HAVE_CHOLMOD
    +(a::PDSparseMat, b::AbstractPDMat) = PDMat(a.mat + Matrix(b))
end

+(a::PDMat, b::PDMat) = PDMat(a.mat + b.mat)
+(a::PDMat, b::PDiagMat) = PDMat(_adddiag(a.mat, b.diag))
+(a::PDMat, b::ScalMat) = PDMat(_adddiag(a.mat, b.value))
if HAVE_CHOLMOD
    +(a::PDMat, b::PDSparseMat) = PDMat(a.mat + b.mat)
end

+(a::PDiagMat, b::PDMat) = PDMat(_adddiag(b.mat, a.diag))
+(a::PDiagMat, b::PDiagMat) = PDiagMat(a.diag + b.diag)
+(a::PDiagMat, b::ScalMat) = PDiagMat(a.diag .+ b.value)
if HAVE_CHOLMOD
    +(a::PDiagMat, b::PDSparseMat) = PDSparseMat(_adddiag(b.mat, a.diag))
end

+(a::ScalMat, b::PDMat) = PDMat(_adddiag(b.mat, a.value))
+(a::ScalMat, b::PDiagMat) = PDiagMat(a.value .+ b.diag)
+(a::ScalMat, b::ScalMat) = ScalMat(a.dim, a.value + b.value)
if HAVE_CHOLMOD
    +(a::ScalMat, b::PDSparseMat) = PDSparseMat(_adddiag(b.mat, a.value))
end

if HAVE_CHOLMOD
    +(a::PDSparseMat, b::PDMat) = PDMat(Matrix(a) + b.mat)
    +(a::PDSparseMat, b::PDiagMat) = PDSparseMat(_adddiag(a.mat, b.diag))
    +(a::PDSparseMat, b::ScalMat) = PDSparseMat(_adddiag(a.mat, b.value))
    +(a::PDSparseMat, b::PDSparseMat) = PDSparseMat(a.mat + b.mat)
end


# between pdmat and uniformscaling (multiple of identity)

+(a::AbstractPDMat, b::UniformScaling) = a + ScalMat(a.dim, b.λ)
+(a::UniformScaling, b::AbstractPDMat) = ScalMat(b.dim, a.λ) + b

pdadd(a::PDMat, b::AbstractPDMat, c::Real) = PDMat(a.mat + Matrix(b * c))
pdadd(a::PDiagMat, b::AbstractPDMat, c::Real) = PDMat(_adddiag!(Matrix(b * c), a.diag, one(c)))
pdadd(a::ScalMat, b::AbstractPDMat, c::Real) = PDMat(_adddiag!(Matrix(b * c), a.value))
if HAVE_CHOLMOD
    pdadd(a::PDSparseMat, b::AbstractPDMat, c::Real) = PDMat(a.mat + Matrix(b * c))
end

pdadd(a::PDMat, b::PDMat, c::Real) = PDMat(a.mat + b.mat * c)
pdadd(a::PDMat, b::PDiagMat, c::Real) = PDMat(_adddiag(a.mat, b.diag, c))
pdadd(a::PDMat, b::ScalMat, c::Real) = PDMat(_adddiag(a.mat, b.value * c))
if HAVE_CHOLMOD
    pdadd(a::PDMat, b::PDSparseMat, c::Real) = PDMat(a.mat + b.mat * c)
end

pdadd(a::PDiagMat, b::PDMat, c::Real) = PDMat(_scaleadddiag(b.mat, c, a.diag))
pdadd(a::PDiagMat, b::PDiagMat, c::Real) = PDiagMat(a.diag + b.diag * c)
pdadd(a::PDiagMat, b::ScalMat, c::Real) = PDiagMat(a.diag .+ b.value * c)
if HAVE_CHOLMOD
    pdadd(a::PDiagMat, b::PDSparseMat, c::Real) = PDSparseMat(_scaleadddiag(b.mat, c, a.diag))
end

pdadd(a::ScalMat, b::PDMat, c::Real) = PDMat(_scaleadddiag(b.mat, c, a.value))
pdadd(a::ScalMat, b::PDiagMat, c::Real) = PDiagMat(a.value .+ b.diag * c)
pdadd(a::ScalMat, b::ScalMat, c::Real) = ScalMat(a.dim, a.value + b.value * c)
if HAVE_CHOLMOD
    pdadd(a::ScalMat, b::PDSparseMat, c::Real) = PDSparseMat(_scaleadddiag(b.mat, c, a.value))
end

if HAVE_CHOLMOD
    pdadd(a::PDSparseMat, b::PDMat, c::Real) = PDMat(a.mat + b.mat * c)
    pdadd(a::PDSparseMat, b::PDiagMat, c::Real) = PDSparseMat(_adddiag(a.mat, b.diag, c))
    pdadd(a::PDSparseMat, b::ScalMat, c::Real) = PDSparseMat(_adddiag(a.mat, b.value * c))
    pdadd(a::PDSparseMat, b::PDSparseMat, c::Real) = PDSparseMat(a.mat + b.mat * c)
end

using LinearAlgebra, PDMats, SparseArrays, SuiteSparse
using Test

@testset "pd matrix types" begin
    for T in [Float64, Float32]
        @testset "test that all external constructors are accessible" begin
            m = Matrix{T}(I, 2, 2)
            @test PDMat(m, cholesky(m)).mat == PDMat(Symmetric(m)).mat == PDMat(m).mat == PDMat(cholesky(m)).mat
            d = ones(T, 2)
            @test @test_deprecated(PDiagMat(d, d)) == PDiagMat(d)
            x = one(T)
            @test @test_deprecated(ScalMat(2, x, x)) == ScalMat(2, x)
            s = SparseMatrixCSC{T}(I, 2, 2)
            @test PDSparseMat(s, cholesky(s)).mat == PDSparseMat(s).mat == PDSparseMat(cholesky(s)).mat
        end

        @testset "test the functionality" begin
            M = convert(Array{T, 2}, [4.0 -2.0 -1.0; -2.0 5.0 -1.0; -1.0 -1.0 6.0])
            V = convert(Array{T, 1}, [1.5, 2.5, 2.0])
            X = convert(T, 2.0)
            f64M = Float64.(M)

            @testset "PDMat from Matrix" begin
                pdf64M = PDMat(f64M)
                test_pdmat(PDMat(M), M, cmat_eq = true, verbose = 1)
                test_pdmat(PDMat{Float64}(M), f64M, cmat_eq = true, verbose = 1)
                test_pdmat(PDMat{Float64, Matrix{Float64}}(M), f64M, cmat_eq = true, verbose = 1)
                @test_throws TypeError PDMat{Float32, Matrix{Float64}}(M)
            end
            @testset "PDMat from PDMat" begin
                pdM = PDMat(M)
                pdf64M = PDMat(f64M)
                @test pdM === PDMat(pdM)
                @test pdf64M === PDMat{Float64}(pdf64M) === PDMat{Float64, Matrix{Float64}}(pdf64M)
                test_pdmat(PDMat(pdM), M, cmat_eq = true, verbose = 1)
                test_pdmat(PDMat{Float64}(pdf64M), f64M, cmat_eq = true, verbose = 1)
                test_pdmat(PDMat{Float64, Matrix{Float64}}(pdf64M), f64M, cmat_eq = true, verbose = 1)
                if Base.VERSION >= v"1.12.0-DEV.1654"   # julia #56562
                    @test isa(convert(typeof(pdf64M), pdM), typeof(pdf64M))
                end
                @test_throws TypeError PDMat{Float32, Matrix{Float64}}(pdM)
            end
            @testset "PDMat from Cholesky" begin
                cholL = Cholesky(Matrix(transpose(cholesky(M).factors)), 'L', 0)
                cholLf64 = Cholesky(Matrix(transpose(cholesky(f64M).factors)), 'L', 0)
                test_pdmat(PDMat(cholL), M, cmat_eq = true, verbose = 1)
                test_pdmat(PDMat{Float64}(cholLf64), f64M, cmat_eq = true, verbose = 1)
                if Base.VERSION >= v"1.12.0-DEV.1654"   # julia #56562
                    test_pdmat(PDMat{Float64, Matrix{Float64}}(cholLf64), f64M, cmat_eq = true, verbose = 1)
                end
            end
            @testset "PDiagMat" begin
                test_pdmat(PDiagMat(V), Matrix(Diagonal(V)), cmat_eq = true, verbose = 1)
            end
            @testset "ScalMat" begin
                test_pdmat(ScalMat(3, X), X * Matrix{T}(I, 3, 3), cmat_eq = true, verbose = 1)
            end
            @testset "PDSparseMat" begin
                test_pdmat(PDSparseMat(sparse(M)), M, cmat_eq = true, verbose = 1, t_eig = false)
            end
        end

        @testset "test deprecated internal constructors" begin
            m = Matrix{T}(I, 2, 2)
            C = cholesky(m)
            @test @test_deprecated(PDMat{T, typeof(m)}(2, m, C)) == PDMat(m)
            d = ones(T, 2)
            @test @test_deprecated(PDiagMat(2, d)) == @test_deprecated(PDiagMat{T, Vector{T}}(2, d)) == PDiagMat(d)
            if HAVE_CHOLMOD
                s = SparseMatrixCSC{T}(I, 2, 2)
                @test @test_deprecated(PDSparseMat{T, typeof(s)}(2, s, cholesky(s))) == PDSparseMat(s)
            end
        end
    end

    @testset "zero-dimensional matrices" begin
        Z = zeros(0, 0)
        test_pdmat(PDMat(Z), Z; t_eig = false)
        test_pdmat(PDiagMat(diag(Z)), Z; t_eig = false)
    end

    @testset "float type conversions" begin
        for T in (Float32, Float64), S in (Float32, Float64, Real)
            A = PDMat(Matrix{T}(I, 2, 2))
            for R in (AbstractArray{S}, AbstractMatrix{S}, AbstractPDMat{S}, PDMat{S})
                B = @inferred(convert(R, A))
                @test B isa PDMat{S}
                @test B == A
                @test (B === A) === (S === T)
                @test (B.mat === A.mat) === (S === T)
                @test (B.chol === A.chol) === (S === T)
            end

            A = PDiagMat(ones(T, 2))
            for R in (AbstractArray{S}, AbstractMatrix{S}, AbstractPDMat{S}, PDiagMat{S})
                B = @inferred(convert(R, A))
                @test B isa PDiagMat{S}
                @test B == A
                @test (B === A) === (S === T)
                @test (B.diag === A.diag) === (S === T)
            end

            A = ScalMat(4, T(1))
            for R in (AbstractArray{S}, AbstractMatrix{S}, AbstractPDMat{S}, ScalMat{S})
                B = @inferred(convert(R, A))
                @test B isa ScalMat{S}
                @test B == A
                @test (B === A) === (S === T)
                # Conversion to `Real` does not change the scalar `value`
                @test (B.value === A.value) === (S === T || S === Real)
            end

            if HAVE_CHOLMOD
                A = PDSparseMat(SparseMatrixCSC{T}(I, 2, 2))
                for R in (AbstractArray{S}, AbstractMatrix{S}, AbstractPDMat{S}, PDSparseMat{S})
                    B = @inferred(convert(R, A))
                    @test B isa PDSparseMat{S}
                    @test B == A
                    @test (B === A) === (S === T)
                    @test (B.mat === A.mat) === (S === T)
                    # CholMOD only supports Float64 and ComplexF64 type parameters!
                    # Hence the Cholesky factorization is reused
                    @test B.chol === A.chol
                end
            end
        end
    end

    @testset "type stability of whiten! and unwhiten!" begin
        a = PDMat([1 0.5; 0.5 1])
        @inferred whiten!(ones(2), a, ones(2))
        @inferred unwhiten!(ones(2), a, ones(2))
        @inferred whiten(a, ones(2))
        @inferred unwhiten(a, ones(2))
    end

    @testset "convert Matrix type to the same Cholesky type (#117)" begin
        @test PDMat([1 0; 0 1]) == [1.0 0.0; 0.0 1.0]
    end

    # https://github.com/JuliaStats/PDMats.jl/pull/141
    @testset "PDiagMat with range" begin
        v = 0.1:0.1:0.5
        d = PDiagMat(v)
        @test d isa PDiagMat{eltype(v), typeof(v)}
        @test d.diag === v
    end

    @testset "division of vectors (size (1, 1))" begin
        A = rand(1, 1)
        x = randn(1)
        y = x / A

        for M in (PDiagMat(vec(A)), ScalMat(1, first(A)))
            z = x / M
            @test typeof(z) === typeof(y)
            @test size(z) == size(y)
            @test z ≈ y
        end

        z = x / PDMat(A)
        @test typeof(z) === typeof(y)
        @test size(z) == size(y)
        @test z ≈ y

        # right division not defined for CHOLMOD:
        # `rdiv!(::Matrix{Float64}, ::SuiteSparse.CHOLMOD.Factor{Float64})` not defined
        if !HAVE_CHOLMOD
            z = x / PDSparseMat(sparse(first(A), 1, 1))
            @test typeof(z) === typeof(y)
            @test size(z) == size(y)
            @test z ≈ y
        end
    end

    @testset "PDMat from Cholesky decomposition of diagonal matrix (#137)" begin
        # U'*U where U isa UpperTriangular etc.
        x = rand(10, 10)
        A = Diagonal(x' * x)
        M = PDMat(cholesky(A))
        @test M isa PDMat{Float64, typeof(A)}
        @test Matrix(M) ≈ A
    end

    @testset "AbstractPDMat constructors (#136)" begin
        x = rand(10, 10)
        A = Array(Symmetric(x' * x + I))

        M = @inferred AbstractPDMat(A)
        @test M isa PDMat
        @test Matrix(M) ≈ A
        Mat32 = @inferred Matrix{Float32}(M)
        @test eltype(Mat32) == Float32
        @test Mat32 ≈ Float32.(A)

        M = @inferred AbstractPDMat(cholesky(A))
        @test M isa PDMat
        @test Matrix(M) ≈ A
        Mat32 = @inferred Matrix{Float32}(M)
        @test Mat32 isa Matrix{Float32}
        @test Mat32 ≈ Float32.(A)

        M = @inferred AbstractPDMat(Diagonal(A))
        @test M isa PDiagMat
        @test Matrix(M) ≈ Diagonal(A)
        Mat32 = @inferred Matrix{Float32}(M)
        @test Mat32 isa Matrix{Float32}
        @test Mat32 ≈ Float32.(Diagonal(A))

        M = @inferred AbstractPDMat(Symmetric(Diagonal(A)))
        @test M isa PDiagMat
        @test Matrix(M) ≈ Diagonal(A)

        M = @inferred AbstractPDMat(Hermitian(Diagonal(A)))
        @test M isa PDiagMat
        @test Matrix(M) ≈ Diagonal(A)

        M = @inferred AbstractPDMat(sparse(A))
        @test M isa PDSparseMat
        @test Matrix(M) ≈ A
        Mat32 = @inferred Matrix{Float32}(M)
        @test Mat32 isa Matrix{Float32}
        @test Mat32 ≈ Float32.(A)

        M = @inferred AbstractPDMat(cholesky(sparse(A)))
        @test M isa PDSparseMat
        @test Matrix(M) ≈ A
    end

    @testset "properties and fields" begin
        for dim in (1, 5, 10)
            x = rand(dim, dim)
            M = PDMat(Array(Symmetric(x' * x + I)))
            @test fieldnames(typeof(M)) == (:mat, :chol)
            @test propertynames(M) == (fieldnames(typeof(M))..., :dim)
            @test getproperty(M, :dim) === dim
            for p in fieldnames(typeof(M))
                @test getproperty(M, p) === getfield(M, p)
            end

            M = PDiagMat(rand(dim))
            @test fieldnames(typeof(M)) == (:diag,)
            @test propertynames(M) == (fieldnames(typeof(M))..., :dim)
            @test getproperty(M, :dim) === dim
            for p in fieldnames(typeof(M))
                @test getproperty(M, p) === getfield(M, p)
            end

            M = ScalMat(dim, rand())
            @test fieldnames(typeof(M)) == (:dim, :value)
            @test propertynames(M) == fieldnames(typeof(M))
            for p in fieldnames(typeof(M))
                @test getproperty(M, p) === getfield(M, p)
            end

            if HAVE_CHOLMOD
                x = sprand(dim, dim, 0.2)
                M = PDSparseMat(sparse(Symmetric(x' * x + I)))
                @test fieldnames(typeof(M)) == (:mat, :chol)
                @test propertynames(M) == (fieldnames(typeof(M))..., :dim)
                @test getproperty(M, :dim) === dim
                for p in fieldnames(typeof(M))
                    @test getproperty(M, p) === getfield(M, p)
                end
            end
        end
    end

    @testset "Incorrect dimensions" begin
        x = rand(10, 10)
        A = Array(Symmetric(x * x' + I))
        C = cholesky(A)
        @test_throws DimensionMismatch PDMat(A[:, 1:(end - 1)], C)
        @test_throws DimensionMismatch PDMat(A[1:(end - 1), 1:(end - 1)], C)

        if HAVE_CHOLMOD
            x = sprand(10, 10, 0.2)
            A = sparse(Symmetric(x * x' + I))
            C = cholesky(A)
            @test_throws DimensionMismatch PDSparseMat(A[:, 1:(end - 1)], C)
            @test_throws DimensionMismatch PDSparseMat(A[1:(end - 1), 1:(end - 1)], C)
        end
    end

    @testset "Subtraction" begin
        # This falls back to the generic method in Julia based on broadcasting
        dim = 4
        x = rand(dim, dim)
        A = PDMat(Array(Symmetric(x' * x + I)))
        @test Base.broadcastable(A) == A.mat

        B = PDiagMat(rand(dim))
        @test Base.broadcastable(B) == Diagonal(B.diag)

        for X in (A, B), Y in (A, B)
            @test X - Y isa (X === Y === B ? Diagonal{Float64, Vector{Float64}} : Matrix{Float64})
            @test X - Y ≈ Matrix(X) - Matrix(Y)
        end

        C = ScalMat(dim, rand())
        @test A - C isa Matrix{Float64}
        @test A - C ≈ Matrix(A) - Matrix(C)
        @test C - A isa Matrix{Float64}
        @test C - A ≈ Matrix(C) - Matrix(A)

        # ScalMat does not behave nicely with PDiagMat
        @test_broken B - C isa Diagonal{Float64, Vector{Float64}}
        @test B - C ≈ Matrix(B) - Matrix(C)
        @test_broken C - B isa Diagonal{Float64, Vector{Float64}}
        @test C - B ≈ Matrix(C) - Matrix(B)
    end
end

using LinearAlgebra, PDMats, Test

@testset "Congruency transforms with PD return values" begin
    shared_typemaps = [
        (ScalMat, ScalMat) => ScalMat,
        (ScalMat, PDiagMat) => PDiagMat,
        (PDiagMat, ScalMat) => PDiagMat,
        (PDiagMat, PDiagMat) => PDiagMat,
    ]
    typemaps = [shared_typemaps..., (PDMat, ScalMat) => PDMat, (PDMat, PDiagMat) => PDMat]
    inv_typemaps = shared_typemaps

    for (fs, tmaps) in
        [((X_A_Xt, Xt_A_X), typemaps), ((X_invA_Xt, Xt_invA_X), inv_typemaps)]
        @testset "$f(::$TA, ::$TB) -> $Tret" for ((TA, TB), Tret) in tmaps, f in fs
            @testset for T in [Float32, Float64],
                    n in [3, 5],
                    uplo in (TA <: PDMat ? ('L', 'U') : (nothing,))

                A = _rand(TA, T, n, uplo)
                B = _rand(TB, T, n, uplo)
                ret = @inferred f(A, B)
                @test ret isa Tret{T}
                @test ret ≈ f(A, Matrix(B))
                if Tret <: PDMat
                    @test cholesky(ret).uplo == cholesky(A).uplo
                    @test Matrix(cholesky(ret)) ≈ ret.mat
                end
            end
        end
    end
end

using PDMats, LinearAlgebra, Test

# Custom subtype for the scalar-multiplication test below; must be top-level since a
# `struct` cannot be defined inside a `@testset`.
struct MyPD <: AbstractPDMat{Float64}
    value::Float64
end
Base.size(::MyPD) = (2, 2)
Base.getindex(a::MyPD, i::Int, j::Int) = i == j ? a.value : 0.0
Base.:*(a::MyPD, c::Real) = MyPD(a.value * c)

@testset "type parameters" begin
    @testset "PDMat quad/invquad specialization for Matrix arguments" begin
        n, k = 200, 500
        M = randn(n, n)
        a = PDMat(M * transpose(M) + n * I)
        x = randn(n, k)
        xcol = x[:, 1]

        # These also compile the Matrix-argument methods used in the allocation checks below.
        @test quad(a, x) ≈ diag(transpose(x) * Matrix(a) * x)
        @test invquad(a, x) ≈ diag(transpose(x) * (a \ x))

        # The specialization reuses one length-n buffer across all columns, so the k-column
        # call allocates the k-element result plus no more scratch than a single column does.
        # The generic fallback instead forms the whole n×k product (~140x more here).
        overhead = 1024
        quad(a, xcol); invquad(a, xcol)
        @test (@allocated quad(a, x)) ≤ sizeof(quad(a, x)) + (@allocated quad(a, xcol)) + overhead
        @test (@allocated invquad(a, x)) ≤ sizeof(invquad(a, x)) + (@allocated invquad(a, xcol)) + overhead

        @test a isa PDMat{<:Real, <:Matrix}
        @test !(a isa PDMat{<:Real, <:Vector})

        for T in (Float64, Float32)
            b = PDMat(Matrix{T}(M * transpose(M) + n * I))
            y = randn(T, n, k)
            @inferred quad(b, y)
            @inferred invquad(b, y)
        end
    end

    @testset "scalar multiplication via generic fallbacks" begin
        # `c * a` and `a / c` delegate to a type's own `a * c` without recursing.
        a = MyPD(3.0)
        @test (a * 2.0).value == 6.0
        @test (2.0 * a).value == 6.0
        @test (a / 2.0).value == 1.5
    end

    @testset "division accepts mismatched operand element types" begin
        n = 4
        mats = Any[_randPDMat(Float64, n), _randPDiagMat(Float64, n), _randScalMat(Float64, n)]
        HAVE_CHOLMOD && push!(mats, _randPDSparseMat(Float64, n))
        operands = (rand(1:5, n), rand(1:5, n, 2), randn(Float32, n), randn(Float32, n, 2))
        for a in mats
            M = Matrix(a)
            for x in operands
                @test a \ x ≈ M \ Array(x)
                xt = permutedims(x)
                @test xt / a ≈ Array(xt) / M
            end
        end
    end

    @testset "ScalMat typed conversion" begin
        a = ScalMat(3, 2.0)
        @test Matrix(a) isa Matrix{Float64}
        @test Matrix(a) == [2.0 0 0; 0 2 0; 0 0 2]
        @test Matrix{Float32}(a) isa Matrix{Float32}
        @test Matrix{Float32}(a) == Float32[2 0 0; 0 2 0; 0 0 2]
    end
end

module StatsBaseExt

using PDMats
using PDMats.LinearAlgebra: Cholesky

using StatsBase: StatsBase, cor2cov, cov2cor

# Fallback
function StatsBase.cor2cov(C::AbstractPDMat, x::AbstractVector{<:Real})
    return X_A_Xt(C, PDiagMat(x))
end

# Exploit possible optimizations of `cor2cov` (for e.g. symmetric matrices)
function StatsBase.cor2cov(C::PDMat, x::AbstractVector{<:Real})
    PDMats.@check_argdims size(C, 1) == length(x)
    mat = cor2cov(C.mat, x)
    uplo = C.chol.uplo
    if uplo === 'U'
        factors = C.chol.factors .* x'
    else
        factors = x .* C.chol.factors
    end
    chol = Cholesky(factors, uplo, C.chol.info)
    return PDMat(mat, chol)
end

# Fallback
function StatsBase.cov2cor(C::AbstractPDMat, x::AbstractVector{<:Real})
    return X_A_Xt(C, PDiagMat(oneunit(eltype(C)) ./ x))
end

# Implementations with reduced allocations
function StatsBase.cov2cor(C::ScalMat, x::AbstractVector{<:Real})
    PDMats.@check_argdims C.dim == length(x)
    return PDiagMat(C.value ./ abs2.(x))
end
StatsBase.cov2cor(C::PDiagMat, x::AbstractVector{<:Real}) = PDiagMat(C.diag ./ abs2.(x))

# Implementations with reduced allocations and exploiting possible optimizations of `cov2cor`
function StatsBase.cov2cor(C::PDMat, x::AbstractVector{<:Real})
    PDMats.@check_argdims size(C, 1) == length(x)
    mat = cov2cor(C.mat, x)
    uplo = C.chol.uplo
    if uplo === 'U'
        factors = C.chol.factors ./ x'
    else
        factors = x .\ C.chol.factors
    end
    chol = Cholesky(factors, uplo, C.chol.info)
    return PDMat(mat, chol)
end

end # module

using LinearAlgebra, PDMats
using PDMats: chol_lower, chol_upper

@testset "chol_lower and chol_upper" begin
    @testset "allocations" begin
        d = 100
        A = rand(d, d)
        C = A'A + I
        invC = inv(C)
        size_of_one_copy = sizeof(C)
        @assert size_of_one_copy > d  # ensure the matrix is large enough that few-byte allocations don't matter

        # allow 5% overhead
        @test chol_lower(C) ≈ chol_upper(C)'
        # The allocation bound is unreliable on Apple (Julia >= 1.11.5): it is met on some
        # machines but exceeded on others (incl. CI), so skip the check there rather than mark
        # it `broken` (which errors on the machines where it happens to pass).
        skip = VERSION >= v"1.11.5" && Sys.isapple()
        @test (@allocated chol_lower(C)) < 1.05 * size_of_one_copy  skip = skip
        @test (@allocated chol_upper(C)) < 1.05 * size_of_one_copy  skip = skip

        X = randn(d, 10)
        for uplo in (:L, :U)
            ch = cholesky(Symmetric(C, uplo))
            @test chol_lower(ch) ≈ chol_upper(ch)'
            @test (@allocated chol_lower(ch)) < 33  # allow small overhead for wrapper types
            @test (@allocated chol_upper(ch)) < 33  # allow small overhead for wrapper types

            # Only test dim, `quad`/`invquad`, `whiten`/`unwhiten`, and tri products
            @test dim(ch) == size(C, 1)
            pdtest_quad(ch, C, invC, X, 0)
            pdtest_triprod(ch, C, invC, X, 0)
            pdtest_whiten(ch, C, 0)
        end
    end

    # issue #120
    @testset "correctness with pivoting" begin
        A = [2 1 1; 1 2 0; 1 0 2]
        x = randn(3)

        # Compute `invquad` without explicit factorization
        b = x' * (A \ x)

        @test sum(abs2, PDMats.chol_lower(A) \ x) ≈ b
        @test sum(abs2, PDMats.chol_upper(A)' \ x) ≈ b

        for uplo in (:L, :U)
            # dense version
            ch_dense = cholesky(Symmetric(A, uplo))
            @test sum(abs2, PDMats.chol_lower(ch_dense) \ x) ≈ b
            @test sum(abs2, PDMats.chol_upper(ch_dense)' \ x) ≈ b

            # sparse version
            if PDMats.HAVE_CHOLMOD
                ch_sparse = cholesky(Symmetric(sparse(A), uplo))
                @test sum(abs2, PDMats.chol_lower(ch_sparse) \ x) ≈ b
                @test sum(abs2, PDMats.chol_upper(ch_sparse)' \ x) ≈ b
            end
        end
    end
end

# deprecated functions

using Base: @deprecate

@deprecate add!(a::Matrix, b::AbstractPDMat) pdadd!(a, b)

@deprecate add_scal!(a::Matrix, b::AbstractPDMat, c::Real) pdadd!(a, b, c)

@deprecate add_scal(a::Matrix, b::AbstractPDMat, c::Real) pdadd(a, b, c)

@deprecate full(x::AbstractPDMat) Matrix(x)

@deprecate CholType Cholesky

@deprecate ScalMat(d::Int, x::Real, inv_x::Real) ScalMat(d, x)
@deprecate PDiagMat(v::AbstractVector, inv_v::AbstractVector) PDiagMat(v)

@deprecate dim(a::AbstractMatrix) LinearAlgebra.checksquare(a)

@deprecate PDMat{T, S}(d::Int, m::AbstractMatrix{T}, c::Cholesky{T, S}) where {T, S} PDMat{T, S}(m, c)

@deprecate PDiagMat(dim::Int, diag::AbstractVector{<:Real}) PDiagMat(diag)
@deprecate PDiagMat{T, V}(dim, diag) where {T <: Real, V <: AbstractVector{T}} PDiagMat{T, V}(diag)

"""
Positive definite diagonal matrix.
"""
struct PDiagMat{T <: Real, V <: AbstractVector{T}} <: AbstractPDMat{T}
    diag::V
end

function Base.getproperty(a::PDiagMat, s::Symbol)
    if s === :dim
        return length(getfield(a, :diag))
    end
    return getfield(a, s)
end
Base.propertynames(::PDiagMat) = (:diag, :dim)

AbstractPDMat(A::Diagonal{<:Real}) = PDiagMat(A.diag)
AbstractPDMat(A::Symmetric{<:Real, <:Diagonal{<:Real}}) = PDiagMat(A.data.diag)
AbstractPDMat(A::Hermitian{<:Real, <:Diagonal{<:Real}}) = PDiagMat(A.data.diag)

### Conversion
Base.convert(::Type{PDiagMat{T}}, a::PDiagMat{T}) where {T <: Real} = a
function Base.convert(::Type{PDiagMat{T}}, a::PDiagMat) where {T <: Real}
    diag = convert(AbstractVector{T}, a.diag)
    return PDiagMat{T, typeof(diag)}(diag)
end
Base.convert(::Type{AbstractPDMat{T}}, a::PDiagMat) where {T <: Real} = convert(PDiagMat{T}, a)

### Basics

Base.size(a::PDiagMat) = (a.dim, a.dim)
Base.Matrix{T}(a::PDiagMat) where {T} = Matrix{T}(Diagonal(a.diag))
LinearAlgebra.diag(a::PDiagMat) = copy(a.diag)
LinearAlgebra.cholesky(a::PDiagMat) = Cholesky(Diagonal(map(sqrt, a.diag)), 'U', 0)

### Treat as a `Diagonal` matrix in broadcasting since that is better supported
Base.broadcastable(a::PDiagMat) = Base.broadcastable(Diagonal(a.diag))

### Inheriting from AbstractMatrix

Base.@propagate_inbounds Base.getindex(a::PDiagMat{T}, i::Int, j::Int) where {T} = i == j ? a.diag[i] : zero(T)

### Arithmetics

function pdadd!(r::Matrix, a::Matrix, b::PDiagMat, c)
    @check_argdims size(r) == size(a) == size(b)
    if r === a
        _adddiag!(r, b.diag, c)
    else
        _adddiag!(copyto!(r, a), b.diag, c)
    end
    return r
end

*(a::PDiagMat, c::Real) = PDiagMat(a.diag * c)
function *(a::PDiagMat, x::AbstractVector)
    @check_argdims a.dim == length(x)
    return a.diag .* x
end
function *(a::PDiagMat, x::AbstractMatrix)
    @check_argdims a.dim == size(x, 1)
    return a.diag .* x
end
function \(a::PDiagMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return x ./ a.diag
end
function /(x::AbstractVecOrMat, a::PDiagMat)
    @check_argdims a.dim == size(x, 2)
    return x ./ (x isa AbstractVector ? a.diag : a.diag')
end
Base.kron(A::PDiagMat, B::PDiagMat) = PDiagMat(vec(permutedims(A.diag) .* B.diag))

### Algebra

Base.inv(a::PDiagMat) = PDiagMat(map(inv, a.diag))
LinearAlgebra.det(a::PDiagMat) = prod(a.diag)
function LinearAlgebra.logdet(a::PDiagMat)
    diag = a.diag
    return isempty(diag) ? zero(log(zero(eltype(diag)))) : sum(log, diag)
end
LinearAlgebra.eigmax(a::PDiagMat) = maximum(a.diag)
LinearAlgebra.eigmin(a::PDiagMat) = minimum(a.diag)
LinearAlgebra.sqrt(a::PDiagMat) = PDiagMat(map(sqrt, a.diag))


### whiten and unwhiten

function whiten!(r::AbstractVecOrMat, a::PDiagMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    return r .= x ./ sqrt.(a.diag)
end
invwhiten!(r::AbstractVecOrMat, a::PDiagMat, x::AbstractVecOrMat) = unwhiten!(r, a, x)
function unwhiten!(r::AbstractVecOrMat, a::PDiagMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    return r .= x .* sqrt.(a.diag)
end
invunwhiten!(r::AbstractVecOrMat, a::PDiagMat, x::AbstractVecOrMat) = whiten!(r, a, x)

function whiten(a::PDiagMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return x ./ sqrt.(a.diag)
end
invwhiten(a::PDiagMat, x::AbstractVecOrMat) = unwhiten(a, x)
function unwhiten(a::PDiagMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return x .* sqrt.(a.diag)
end
invunwhiten(a::PDiagMat, x::AbstractVecOrMat) = whiten(a, x)

### quadratic forms

function quad(a::PDiagMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    if x isa AbstractVector
        return wsumsq(a.diag, x)
    else
        # map(Base.Fix1(invquad, a), eachcol(x)) or similar alternatives
        # do NOT return a `SVector` for inputs `x::SMatrix`.
        return vec(sum(abs2.(x) .* a.diag; dims = 1))
    end
end

function quad!(r::AbstractArray, a::PDiagMat, x::AbstractMatrix)
    ad = a.diag
    @check_argdims eachindex(ad) == axes(x, 1)
    @check_argdims eachindex(r) == axes(x, 2)
    @inbounds for j in axes(x, 2)
        s = zero(promote_type(eltype(ad), eltype(x)))
        for i in axes(x, 1)
            s += ad[i] * abs2(x[i, j])
        end
        r[j] = s
    end
    return r
end

function invquad(a::PDiagMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    if x isa AbstractVector
        return invwsumsq(a.diag, x)
    else
        # map(Base.Fix1(invquad, a), eachcol(x)) or similar alternatives
        # do NOT return a `SVector` for inputs `x::SMatrix`.
        return vec(sum(abs2.(x) ./ a.diag; dims = 1))
    end
end

function invquad!(r::AbstractArray, a::PDiagMat, x::AbstractMatrix)
    ad = a.diag
    @check_argdims eachindex(ad) == axes(x, 1)
    @check_argdims eachindex(r) == axes(x, 2)
    @inbounds for j in axes(x, 2)
        s = zero(zero(eltype(x)) / zero(eltype(ad)))
        for i in axes(x, 1)
            s += abs2(x[i, j]) / ad[i]
        end
        r[j] = s
    end
    return r
end


### tri products

function X_A_Xt(a::PDiagMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 2)
    z = a.diag .* transpose(x)
    return Symmetric(x * z)
end

function Xt_A_X(a::PDiagMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 1)
    z = a.diag .* x
    return Symmetric(transpose(x) * z)
end

function X_invA_Xt(a::PDiagMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 2)
    z = transpose(x) ./ a.diag
    return Symmetric(x * z)
end

function Xt_invA_X(a::PDiagMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 1)
    z = x ./ a.diag
    return Symmetric(transpose(x) * z)
end

### Specializations for `Array` arguments with reduced allocations

function quad(a::PDiagMat{<:Real, <:Vector}, x::Matrix)
    @check_argdims a.dim == size(x, 1)
    T = typeof(zero(eltype(a)) * abs2(zero(eltype(x))))
    return quad!(Vector{T}(undef, size(x, 2)), a, x)
end

function invquad(a::PDiagMat{<:Real, <:Vector}, x::Matrix)
    @check_argdims a.dim == size(x, 1)
    T = typeof(abs2(zero(eltype(x))) / zero(eltype(a)))
    return invquad!(Vector{T}(undef, size(x, 2)), a, x)
end

using PDMats
using Test
using LinearAlgebra: LinearAlgebra

function _pd_sqrt_compare(A::AbstractPDMat)
    PDAsqrt = sqrt(A)
    Asqrt_dense = sqrt(Matrix(A))
    pdtest_cmat(PDAsqrt, Asqrt_dense, false, 0)
    pdtest_diag(PDAsqrt, Asqrt_dense, false, 0)
    pdtest_scale(PDAsqrt, Asqrt_dense, 0)
    return PDAsqrt, Asqrt_dense
end

n = 10

@testset "Matrix square root" begin
    for T in [Float32, Float64]
        _pd_sqrt_compare(_randPDMat(T, n))
        _pd_sqrt_compare(_randPDiagMat(T, n))
        _pd_sqrt_compare(_randScalMat(T, n))
        _pd_sqrt_compare(_randPDSparseMat(T, n))
    end
end

using BandedMatrices
using StaticArrays

@testset "Special matrix types" begin
    @testset "StaticArrays" begin
        # Full matrix
        S = (x -> SMatrix{4, 4}(Symmetric(x * x' + I)))(@SMatrix(randn(4, 7)))
        PDS = PDMat(S)
        @test PDS isa PDMat{Float64, <:SMatrix{4, 4, Float64}}
        @test isbits(PDS)
        C = cholesky(S)
        PDC = PDMat(C)
        @test typeof(PDC) === typeof(PDS)
        @test Matrix(PDC) ≈ Matrix(PDS)
        @test PDMat(S, C) === PDS
        @test @allocated(PDMat(S)) == @allocated(PDMat(C)) == @allocated(PDMat(S, C))

        if Base.VERSION >= v"1.12.0-DEV.1654"    # julia #56562
            A = PDMat(Matrix{Float64}(I, 2, 2))
            B = PDMat(SMatrix{2, 2, Float64}(I))
            @test !isa(A.mat, typeof(B.mat))
            S = convert(typeof(B), A)
            @test  isa(S.mat, typeof(B.mat))
        end

        # Diagonal matrix
        D = PDiagMat(@SVector(rand(4)))
        @test D isa PDiagMat{Float64, <:SVector{4, Float64}}
        @test @inferred(kron(D, D)) isa PDiagMat{Float64, <:SVector{16, Float64}}

        # Scaled identity matrix
        E = ScalMat(4, 1.2)

        x = @SVector rand(4)
        X = @SMatrix rand(10, 4)
        Y = @SMatrix rand(4, 10)

        for A in (PDS, D, E, C)
            @test Matrix(A) isa Matrix

            if !(A isa Cholesky)
                # `*(::Cholesky, ::SArray)` is not defined
                @test A * x isa SVector{4, Float64}
                @test A * x ≈ Matrix(A) * Vector(x)

                @test A * Y isa SMatrix{4, 10, Float64}
                @test A * Y ≈ Matrix(A) * Matrix(Y)
            end

            @test X / A isa SMatrix{10, 4, Float64}
            @test X / A ≈ Matrix(X) / Matrix(A)

            @test A \ x isa SVector{4, Float64}
            @test A \ x ≈ Matrix(A) \ Vector(x)

            @test A \ Y isa SMatrix{4, 10, Float64}
            @test A \ Y ≈ Matrix(A) \ Matrix(Y)

            @test whiten(A, x) isa SVector{4, Float64}
            @test whiten(A, x) ≈ cholesky(Symmetric(Matrix(A))).L \ Vector(x)

            @test whiten(A, Y) isa SMatrix{4, 10, Float64}
            @test whiten(A, Y) ≈ cholesky(Symmetric(Matrix(A))).L \ Matrix(Y)

            @test unwhiten(A, x) isa SVector{4, Float64}
            @test unwhiten(A, x) ≈ cholesky(Symmetric(Matrix(A))).L * Vector(x)

            @test unwhiten(A, Y) isa SMatrix{4, 10, Float64}
            @test unwhiten(A, Y) ≈ cholesky(Symmetric(Matrix(A))).L * Matrix(Y)

            @test quad(A, x) isa Float64
            @test quad(A, x) ≈ Vector(x)' * Matrix(A) * Vector(x)

            @test quad(A, Y) isa SVector{10, Float64}
            @test quad(A, Y) ≈ diag(Matrix(Y)' * Matrix(A) * Matrix(Y))

            @test invquad(A, x) isa Float64
            @test invquad(A, x) ≈ Vector(x)' * (Matrix(A) \ Vector(x))

            @test invquad(A, Y) isa SVector{10, Float64}
            @test invquad(A, Y) ≈ diag(Matrix(Y)' * (Matrix(A) \ Matrix(Y)))

            @test X_A_Xt(A, X) isa Symmetric{Float64, <:SMatrix{10, 10, Float64}}
            @test X_A_Xt(A, X) ≈ Matrix(X) * Matrix(A) * Matrix(X)'

            @test X_invA_Xt(A, X) isa Symmetric{Float64, <:SMatrix{10, 10, Float64}}
            @test X_invA_Xt(A, X) ≈ Matrix(X) * (Matrix(A) \ Matrix(X)')

            @test Xt_A_X(A, Y) isa Symmetric{Float64, <:SMatrix{10, 10, Float64}}
            @test Xt_A_X(A, Y) ≈ Matrix(Y)' * Matrix(A) * Matrix(Y)

            @test Xt_invA_X(A, Y) isa Symmetric{Float64, <:SMatrix{10, 10, Float64}}
            @test Xt_invA_X(A, Y) ≈ Matrix(Y)' * (Matrix(A) \ Matrix(Y))
        end

        # Subtraction falls back to the generic method in Base which is based on broadcasting
        @test Base.broadcastable(PDS) == PDS.mat
        @test Base.broadcastable(D) == Diagonal(D.diag)
        for A in (PDS, D), B in (PDS, D)
            @test A - B isa SMatrix{4, 4, Float64}
            @test A - B ≈ Matrix(A) - Matrix(B)
        end

        # ScalMat does not behave nicely with broadcasting currently
        for A in (PDS, D)
            @test_broken A - E isa SMatrix{4, 4, Float64}
            @test_broken E - A isa SMatrix{4, 4, Float64}
            @test A - E ≈ Matrix(A) - Matrix(E)
            @test E - A ≈ Matrix(E) - Matrix(A)
        end
    end

    @testset "BandedMatrices" begin
        # Full matrix
        A = Symmetric(BandedMatrix(Eye(5), (1, 1)))
        P = PDMat(A)
        @test P isa PDMat{Float64, <:BandedMatrix{Float64}}

        x = rand(5)
        X = rand(2, 5)
        Y = rand(5, 2)
        @test P * x ≈ x
        @test P * Y ≈ Y
        @test X / P ≈ X
        @test P \ x ≈ x
        @test P \ Y ≈ Y
        @test X_A_Xt(P, X) ≈ X * X'
        @test X_invA_Xt(P, X) ≈ X * X'
        @test Xt_A_X(P, Y) ≈ Y' * Y
        @test Xt_invA_X(P, Y) ≈ Y' * Y
    end
end

# Generic functions (on top of the type-specific implementations)

## constructors
AbstractPDMat(A::AbstractPDMat) = A
AbstractPDMat(A::AbstractMatrix) = PDMat(A)

## convert
Base.convert(::Type{AbstractMatrix{T}}, a::AbstractPDMat) where {T <: Real} = convert(AbstractPDMat{T}, a)
Base.convert(::Type{AbstractArray{T}}, a::AbstractPDMat) where {T <: Real} = convert(AbstractMatrix{T}, a)

## arithmetics

pdadd!(r::Matrix, a::Matrix, b::AbstractPDMat{T}) where {T <: Real} = pdadd!(r, a, b, one(T))

pdadd!(a::Matrix, b::AbstractPDMat, c) = pdadd!(a, a, b, c)
pdadd!(a::Matrix, b::AbstractPDMat{T}) where {T <: Real} = pdadd!(a, a, b, one(T))

pdadd(a::Matrix{T}, b::AbstractPDMat{S}, c::R) where {T <: Real, S <: Real, R <: Real} = pdadd!(similar(a, promote_type(T, S, R)), a, b, c)
pdadd(a::Matrix{T}, b::AbstractPDMat{S}) where {T <: Real, S <: Real} = pdadd!(similar(a, promote_type(T, S)), a, b, one(T))

+(a::Matrix, b::AbstractPDMat) = pdadd(a, b)
+(a::AbstractPDMat, b::Matrix) = pdadd(b, a)

*(c::T, a::AbstractPDMat) where {T <: Real} = a * c
/(a::AbstractPDMat, c::T) where {T <: Real} = a * inv(c)
Base.kron(A::AbstractPDMat, B::AbstractPDMat) = PDMat(kron(Matrix(A), Matrix(B)))

# LinearAlgebra
LinearAlgebra.isposdef(::AbstractPDMat) = true
LinearAlgebra.ishermitian(::AbstractPDMat) = true
LinearAlgebra.checksquare(a::AbstractPDMat) = size(a, 1)
LinearAlgebra.ldiv!(A::AbstractPDMat, B::AbstractVecOrMat) = ldiv!(cholesky(A), B)

## whiten and unwhiten

"""
    whiten(a::AbstractMatrix, x::AbstractVecOrMat)
    whiten!(a::AbstractMatrix, x::AbstractVecOrMat)
    whiten!(r::AbstractVecOrMat, a::AbstractPDMat, x::AbstractVecOrMat)

Allocating and in-place versions of the `whiten`ing transform defined by `a` applied to `x`.

If the covariance of `x` is `a` then the covariance of the result will be `I`.
The name `whiten` indicates that this function transforms a correlated multivariate random
variable to "white noise".

```jldoctest
julia> using PDMats

julia> X = vcat(ones(4)', (1:4)')
2×4 Array{Float64,2}:
 1.0  1.0  1.0  1.0
 1.0  2.0  3.0  4.0

julia> a = PDMat(X * X')
PDMat{Float64, Matrix{Float64}, Cholesky{Float64, Matrix{Float64}}}([4.0 10.0; 10.0 30.0], Cholesky{Float64, Matrix{Float64}}([2.0 5.0; 10.0 2.23607], 'U', 0))

julia> W = whiten(a, X)
2×4 Array{Float64,2}:
  0.5       0.5       0.5       0.5
 -0.67082  -0.223607  0.223607  0.67082

julia> W * W'
2×2 Array{Float64,2}:
 1.0  0.0
 0.0  1.0
```

`whiten` is the inverse transformation of [`unwhiten`](@ref).

See also [`invwhiten`](@ref) and [`invunwhiten`](ref)
"""
whiten(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat) = whiten(AbstractPDMat(a), x)

"""
    invwhiten(a::AbstractMatrix, x::AbstractVecOrMat)
    invwhiten!(a::AbstractMatrix, x::AbstractVecOrMat)
    invwhiten!(r::AbstractVecOrMat, a::AbstractPDMat, x::AbstractVecOrMat)

Allocating and in-place versions of the `whiten`ing transform defined by `inv(a)` applied to `x`.

If the precision of `x` is `a` then the covariance of the result will be `I`.
The name `invwhiten` indicates that this function transforms a correlated multivariate random
variable to "white noise".

`invwhiten` is the inverse transformation of [`invunwhiten`](@ref).

See also [`whiten`](@ref) and [`unwhiten`](@ref)
"""
invwhiten(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat) = invwhiten(AbstractPDMat(a), x)

"""
    unwhiten(a::AbstractMatrix, x::AbstractVecOrMat)
    unwhiten!(a::AbstractMatrix, x::AbstractVecOrMat)
    unwhiten!(r::AbstractVecOrMat, a::AbstractPDMat, x::AbstractVecOrMat)

Allocating and in-place versions of the `unwhiten`ing transform defined by `a` applied to `x`.

If the covariance of `x` is `I` then the covariance of the result will be `a`.
The name `unwhiten` indicates that this function transforms an uncorrelated "white noise" signal
into a signal with the given covariance.

`unwhiten` is the inverse transformation of [`whiten`](@ref).

See also [`invwhiten`](@ref) and [`invunwhiten`](@ref)
"""
unwhiten(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat) = unwhiten(AbstractPDMat(a), x)

"""
    invunwhiten(a::AbstractMatrix, x::AbstractVecOrMat)
    invunwhiten!(a::AbstractMatrix, x::AbstractVecOrMat)
    invunwhiten!(r::AbstractVecOrMat, a::AbstractPDMat, x::AbstractVecOrMat)

Allocating and in-place versions of the `unwhiten`ing transform defined by `inv(a)` applied to `x`.

If the covariance of `x` is `I` then the precision of the result will be `a`.
The name `invunwhiten` indicates that this function transforms an uncorrelated "white noise" signal
into a signal with the given covariance.

`invunwhiten` is the inverse transformation of [`invwhiten`](@ref).

See also [`whiten`](@ref) and [`unwhiten`](@ref)
"""
invunwhiten(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat) = invunwhiten(AbstractPDMat(a), x)

whiten!(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat) = whiten!(x, a, x)
invwhiten!(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat) = invwhiten!(x, a, x)
unwhiten!(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat) = unwhiten!(x, a, x)
invunwhiten!(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat) = invunwhiten!(x, a, x)

function whiten!(r::AbstractVecOrMat, a::AbstractMatrix{<:Real}, x::AbstractVecOrMat)
    return whiten!(r, AbstractPDMat(a), x)
end
function invwhiten!(r::AbstractVecOrMat, a::AbstractMatrix{<:Real}, x::AbstractVecOrMat)
    return invwhiten!(r, AbstractPDMat(a), x)
end
function unwhiten!(r::AbstractVecOrMat, a::AbstractMatrix{<:Real}, x::AbstractVecOrMat)
    return unwhiten!(r, AbstractPDMat(a), x)
end
function invunwhiten!(r::AbstractVecOrMat, a::AbstractMatrix{<:Real}, x::AbstractVecOrMat)
    return invunwhiten!(r, AbstractPDMat(a), x)
end

## quad

"""
    quad(a::AbstractMatrix, x::AbstractVecOrMat)

Return the value of the quadratic form defined by `a` applied to `x`.

If `x` is a vector the quadratic form is `x' * a * x`.  If `x` is a matrix
the quadratic form is applied column-wise.
"""
function quad(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat)
    return quad(AbstractPDMat(a), x)
end

"""
    quad!(r::AbstractArray, a::AbstractMatrix, x::AbstractMatrix)

Overwrite `r` with the value of the quadratic form defined by `a` applied columnwise to `x`.
"""
function quad!(r::AbstractArray, a::AbstractMatrix{<:Real}, x::AbstractMatrix)
    return quad!(r, AbstractPDMat(a), x)
end

"""
    invquad(a::AbstractMatrix, x::AbstractVecOrMat)

Return the value of the quadratic form defined by `inv(a)` applied to `x`.

For most `PDMat` types this is done in a way that does not require evaluation of `inv(a)`.

If `x` is a vector the quadratic form is `x' * a * x`.  If `x` is a matrix
the quadratic form is applied column-wise.
"""
function invquad(a::AbstractMatrix{<:Real}, x::AbstractVecOrMat)
    return invquad(AbstractPDMat(a), x)
end

"""
    invquad!(r::AbstractArray, a::AbstractMatrix, x::AbstractMatrix)

Overwrite `r` with the value of the quadratic form defined by `inv(a)` applied columnwise to `x`
"""
function invquad!(r::AbstractArray, a::AbstractMatrix{<:Real}, x::AbstractMatrix)
    return invquad!(r, AbstractPDMat(a), x)
end

"""
Sparse positive definite matrix together with a Cholesky factorization object.
"""
struct PDSparseMat{T <: Real, S <: AbstractSparseMatrix} <: AbstractPDMat{T}
    mat::S
    chol::CholTypeSparse

    PDSparseMat{T, S}(m::AbstractSparseMatrix{T}, c::CholTypeSparse) where {T, S} =
        new{T, S}(m, c) #add {T} to CholTypeSparse argument once #14076 is implemented
end
@deprecate PDSparseMat{T, S}(d::Int, m::AbstractSparseMatrix{T}, c::CholTypeSparse) where {T, S} PDSparseMat{T, S}(m, c)

function PDSparseMat(mat::AbstractSparseMatrix, chol::CholTypeSparse)
    d = LinearAlgebra.checksquare(mat)
    size(chol, 1) == d ||
        throw(DimensionMismatch("Dimensions of mat and chol are inconsistent."))
    return PDSparseMat{eltype(mat), typeof(mat)}(mat, chol)
end

PDSparseMat(mat::SparseMatrixCSC) = PDSparseMat(mat, cholesky(mat))
PDSparseMat(fac::CholTypeSparse) = PDSparseMat(sparse(fac), fac)

function Base.getproperty(a::PDSparseMat, s::Symbol)
    if s === :dim
        return size(getfield(a, :mat), 1)
    end
    return getfield(a, s)
end
Base.propertynames(::PDSparseMat) = (:mat, :chol, :dim)

AbstractPDMat(A::SparseMatrixCSC) = PDSparseMat(A)
AbstractPDMat(A::CholTypeSparse) = PDSparseMat(A)

### Conversion
Base.convert(::Type{PDSparseMat{T}}, a::PDSparseMat{T}) where {T <: Real} = a
function Base.convert(::Type{PDSparseMat{T}}, a::PDSparseMat) where {T <: Real}
    # CholTypeSparse only supports Float64 and ComplexF64 type parameters!
    # So there is no point in recomputing `cholesky(mat)` and we just reuse
    # the existing Cholesky factorization
    mat = convert(AbstractMatrix{T}, a.mat)
    return PDSparseMat{T, typeof(mat)}(mat, a.chol)
end
Base.convert(::Type{AbstractPDMat{T}}, a::PDSparseMat) where {T <: Real} = convert(PDSparseMat{T}, a)

### Basics

Base.size(a::PDSparseMat) = (a.dim, a.dim)
Base.Matrix{T}(a::PDSparseMat) where {T} = Matrix{T}(a.mat)
LinearAlgebra.diag(a::PDSparseMat) = diag(a.mat)
LinearAlgebra.cholesky(a::PDSparseMat) = a.chol

### Inheriting from AbstractMatrix

Base.IndexStyle(::Type{PDSparseMat{T, S}}) where {T, S} = IndexStyle(S)
# Linear Indexing
Base.@propagate_inbounds Base.getindex(a::PDSparseMat, i::Int) = getindex(a.mat, i)
# Cartesian Indexing
Base.@propagate_inbounds Base.getindex(a::PDSparseMat, I::Vararg{Int, 2}) = getindex(a.mat, I...)

### Arithmetics

# add `a * c` to a dense matrix `m` of the same size inplace.
function pdadd!(r::Matrix, a::Matrix, b::PDSparseMat, c)
    @check_argdims size(r) == size(a) == size(b)
    return _addscal!(r, a, b.mat, c)
end

*(a::PDSparseMat, c::Real) = PDSparseMat(a.mat * c)
*(a::PDSparseMat, x::AbstractMatrix) = a.mat * x  # defining these seperately to avoid
*(a::PDSparseMat, x::AbstractVector) = a.mat * x  # ambiguity errors
# `x` is converted to `Float64` to work around CHOLMOD limitations (julia issue #14076).
function \(a::PDSparseMat, x::AbstractVecOrMat{<:Real})
    @check_argdims a.dim == size(x, 1)
    T = promote_type(eltype(a), eltype(x))
    return convert(Array{T}, a.chol \ convert(Array{Float64}, x))
end
function /(x::AbstractVecOrMat{<:Real}, a::PDSparseMat)
    @check_argdims a.dim == size(x, 2)
    # CHOLMOD does not support `/`, but `a` is symmetric: `x / a == (a \ xᵀ)ᵀ`.
    z = a \ transpose(x)
    return x isa AbstractVector ? vec(z) : permutedims(z)
end

### Algebra

Base.inv(a::PDSparseMat{T}) where {T <: Real} = PDMat(inv(a.mat))
LinearAlgebra.det(a::PDSparseMat) = det(a.chol)
LinearAlgebra.logdet(a::PDSparseMat) = logdet(a.chol)
LinearAlgebra.sqrt(A::PDSparseMat) = PDMat(sqrt(Hermitian(Matrix(A))))

### whiten and unwhiten

function whiten!(r::AbstractVecOrMat, a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    # Can't use `ldiv!` due to missing support in SparseArrays
    return copyto!(r, chol_lower(a.chol) \ x)
end
function invwhiten!(r::AbstractVecOrMat, a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    # `*` and `mul!` are not defined for `UP` factor components,
    # so we can't use `chol_upper(C) * x`
    # `sparse` is neither defined for `PtL` nor for `UP` nor for `U` factor components
    C = cholesky(a)
    PtL = sparse(C.L)[C.p, :]
    return copyto!(r, PtL' * x)
end

function unwhiten!(r::AbstractVecOrMat, a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    # `*` is not defined for `PtL` factor components,
    # so we can't use `chol_lower(C) * x`
    # `sparse` is neither defined for `PtL` nor for `UP` nor for `U` factor components
    C = cholesky(a)
    PtL = sparse(C.L)[C.p, :]
    return copyto!(r, PtL * x)
end
function invunwhiten!(r::AbstractVecOrMat, a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    # Can't use `ldiv!` due to missing support in SparseArrays
    return copyto!(r, chol_upper(cholesky(a)) \ x)
end

function whiten(a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return chol_lower(cholesky(a)) \ x
end
function invwhiten(a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    # `*` is not defined for `UP` factor components,
    # so we can't use `chol_upper(C) * x`
    # `sparse` is neither defined for `PtL` nor for `UP` nor for `U` factor components
    C = cholesky(a)
    PtL = sparse(C.L)[C.p, :]
    return PtL' * x
end

function unwhiten(a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    # `*` is not defined for `PtL` factor components,
    # so we can't use `chol_lower(C) * x`
    # `sparse` is neither defined for `PtL` nor for `UP` nor for `U` factor components
    C = cholesky(a)
    PtL = sparse(C.L)[C.p, :]
    return PtL * x
end
function invunwhiten(a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return chol_upper(cholesky(a)) \ x
end

### quadratic forms

function quad(a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return x isa AbstractVector ? dot(x, a.mat, x) : map(Base.Fix1(quad, a), eachcol(x))
end

function quad!(r::AbstractArray, a::PDSparseMat, x::AbstractMatrix)
    @check_argdims eachindex(r) == axes(x, 2)
    @inbounds for i in axes(x, 2)
        xi = view(x, :, i)
        r[i] = dot(xi, a.mat, xi)
    end
    return r
end

function invquad(a::PDSparseMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    z = a.chol \ x
    return x isa AbstractVector ? dot(x, z) : map(dot, eachcol(x), eachcol(z))
end

function invquad!(r::AbstractArray, a::PDSparseMat, x::AbstractMatrix)
    @check_argdims eachindex(r) == axes(x, 2)
    @check_argdims a.dim == size(x, 1)
    # Can't use `ldiv!` with buffer due to missing support in SparseArrays
    @inbounds for i in axes(x, 2)
        xi = view(x, :, i)
        r[i] = dot(xi, a.chol \ xi)
    end
    return r
end


### tri products

function X_A_Xt(a::PDSparseMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 2)
    z = a.mat * transpose(x)
    return Symmetric(x * z)
end


function Xt_A_X(a::PDSparseMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 1)
    z = a.mat * x
    return Symmetric(transpose(x) * z)
end


function X_invA_Xt(a::PDSparseMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 2)
    z = a.chol \ collect(transpose(x))
    return Symmetric(x * z)
end

function Xt_invA_X(a::PDSparseMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 1)
    z = a.chol \ x
    return Symmetric(transpose(x) * z)
end

"""
Full positive definite matrix together with a Cholesky factorization object.
"""
struct PDMat{T <: Real, S <: AbstractMatrix{T}, C <: Cholesky{T}} <: AbstractPDMat{T}
    mat::S
    chol::C

    function PDMat{T, S, C}(m::AbstractMatrix, c::Cholesky) where {T <: Real, S <: AbstractMatrix{T}, C <: Cholesky{T}}
        d = LinearAlgebra.checksquare(m)
        if size(c, 1) != d
            throw(DimensionMismatch("Dimensions of mat and chol are inconsistent."))
        end
        # in principle we might want to check that `c` is a Cholesky factorization of `m`,
        # but that's slow
        return new{T, S, C}(m, c)
    end
end
function PDMat{T, S}(m::AbstractMatrix, c::Cholesky) where {T <: Real, S <: AbstractMatrix{T}}
    c = convert(Cholesky{T}, c)
    return PDMat{T, S, typeof(c)}(m, c)
end
function PDMat{T}(m::AbstractMatrix, c::Cholesky) where {T <: Real}
    m = convert(AbstractMatrix{T}, m)
    c = convert(Cholesky{T}, c)
    return PDMat{T, typeof(m), typeof(c)}(m, c)
end
# `mat` and `chol` may use different array types (xref #237). Keep both as-is if
# the element types match, otherwise promote them.
function PDMat(mat::AbstractMatrix{T}, chol::Cholesky{T}) where {T <: Real}
    return PDMat{T, typeof(mat), typeof(chol)}(mat, chol)
end
function PDMat(mat::AbstractMatrix, chol::Cholesky)
    T = promote_type(eltype(mat), eltype(chol))
    return PDMat(convert(AbstractMatrix{T}, mat), convert(Cholesky{T}, chol))
end

# Construction from another PDMat
PDMat{T, S, C}(pdm::PDMat{T, S, C}) where {T <: Real, S <: AbstractMatrix{T}, C <: Cholesky{T}} = pdm  # since PDMat doesn't support `setindex!` it's not mutable (xref https://docs.julialang.org/en/v1/manual/conversion-and-promotion/#Mutable-collections)
PDMat{T, S, C}(pdm::PDMat) where {T <: Real, S <: AbstractMatrix{T}, C <: Cholesky{T}} = PDMat{T, S, C}(pdm.mat, pdm.chol)
PDMat{T, S}(pdm::PDMat{T, S}) where {T <: Real, S <: AbstractMatrix{T}} = pdm
PDMat{T, S}(pdm::PDMat) where {T <: Real, S <: AbstractMatrix{T}} = PDMat{T, S}(pdm.mat, pdm.chol)
PDMat{T}(pdm::PDMat{T}) where {T <: Real} = pdm
PDMat{T}(pdm::PDMat) where {T <: Real} = PDMat{T}(pdm.mat, pdm.chol)
PDMat(pdm::PDMat) = pdm

# Construction from an AbstractMatrix
function PDMat{T, S}(mat::AbstractMatrix) where {T <: Real, S <: AbstractMatrix{T}}
    mat = convert(S, mat)
    return PDMat{T, S}(mat, cholesky(mat))
end
function PDMat{T}(mat::AbstractMatrix) where {T <: Real}
    mat = convert(AbstractMatrix{T}, mat)
    return PDMat{T}(mat, cholesky(mat))
end
PDMat(mat::AbstractMatrix) = PDMat(mat, cholesky(mat))

# Construction from a Cholesky factorization
function PDMat{T, S}(c::Cholesky) where {T <: Real, S <: AbstractMatrix{T}}
    c = convert(Cholesky{T, S}, c)
    return PDMat{T, S}(AbstractMatrix(c), c)
end
function PDMat{T}(c::Cholesky) where {T <: Real}
    c = convert(Cholesky{T}, c)
    return PDMat{T}(AbstractMatrix(c), c)
end
PDMat(c::Cholesky) = PDMat(AbstractMatrix(c), c)

function Base.getproperty(a::PDMat, s::Symbol)
    if s === :dim
        return size(getfield(a, :mat), 1)
    end
    return getfield(a, s)
end
Base.propertynames(::PDMat) = (:mat, :chol, :dim)

AbstractPDMat(A::Cholesky) = PDMat(A)

### Conversion
# This next method isn't needed because PDMat{T}(a) returns `a` directly
# Base.convert(::Type{PDMat{T}}, a::PDMat{T}) where {T<:Real} = a
Base.convert(::Type{PDMat{T}}, a::PDMat) where {T <: Real} = PDMat{T}(a)
Base.convert(::Type{PDMat{T, S}}, a::PDMat) where {T <: Real, S <: AbstractMatrix{T}} = PDMat{T, S}(a)
Base.convert(::Type{PDMat{T, S, C}}, a::PDMat) where {T <: Real, S <: AbstractMatrix{T}, C <: Cholesky{T}} = PDMat{T, S, C}(a)

Base.convert(::Type{AbstractPDMat{T}}, a::PDMat) where {T <: Real} = convert(PDMat{T}, a)

### Basics

Base.size(a::PDMat) = (a.dim, a.dim)
Base.Matrix{T}(a::PDMat) where {T} = Matrix{T}(a.mat)
LinearAlgebra.diag(a::PDMat) = diag(a.mat)
LinearAlgebra.cholesky(a::PDMat) = a.chol

### Work with the underlying matrix in broadcasting
Base.broadcastable(a::PDMat) = Base.broadcastable(a.mat)

### Inheriting from AbstractMatrix

Base.IndexStyle(::Type{<:PDMat{T, S}}) where {T, S} = Base.IndexStyle(S)
# Linear Indexing
Base.@propagate_inbounds Base.getindex(a::PDMat, i::Int) = getindex(a.mat, i)
# Cartesian Indexing
Base.@propagate_inbounds Base.getindex(a::PDMat, i::Int, j::Int) = getindex(a.mat, i, j)

### Arithmetics

function pdadd!(r::Matrix, a::Matrix, b::PDMat, c)
    @check_argdims size(r) == size(a) == size(b)
    return _addscal!(r, a, b.mat, c)
end

*(a::PDMat, c::Real) = PDMat(a.mat * c)
*(a::PDMat, x::AbstractVector) = a.mat * x
*(a::PDMat, x::AbstractMatrix) = a.mat * x
\(a::PDMat, x::AbstractVecOrMat) = a.chol \ x
function /(x::AbstractVecOrMat, a::PDMat)
    # /(::AbstractVector, ::Cholesky) is not defined
    if x isa AbstractVector
        return vec(reshape(x, Val(2)) / a.chol)
    else
        return x / a.chol
    end
end

### Algebra

Base.inv(a::PDMat) = PDMat(inv(a.chol))
LinearAlgebra.det(a::PDMat) = det(a.chol)
LinearAlgebra.logdet(a::PDMat) = logdet(a.chol)
LinearAlgebra.eigmax(a::PDMat) = eigmax(Symmetric(a.mat))
LinearAlgebra.eigmin(a::PDMat) = eigmin(Symmetric(a.mat))
function Base.kron(A::PDMat, B::PDMat)
    M = kron(A.mat, B.mat)
    C = Cholesky(UpperTriangular(kron(chol_upper(A.chol), chol_upper(B.chol))))
    return PDMat(M, C)
end
LinearAlgebra.sqrt(A::PDMat) = PDMat(sqrt(Hermitian(A.mat)))

### (un)whitening

function whiten!(r::AbstractVecOrMat, a::PDMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    if r === x
        return ldiv!(chol_lower(cholesky(a)), r)
    else
        return ldiv!(r, chol_lower(cholesky(a)), x)
    end
end
function invwhiten!(r::AbstractVecOrMat, a::PDMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    if r === x
        return lmul!(chol_upper(cholesky(a)), r)
    else
        return mul!(r, chol_upper(cholesky(a)), x)
    end
end
function unwhiten!(r::AbstractVecOrMat, a::PDMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    if r === x
        return lmul!(chol_lower(cholesky(a)), r)
    else
        return mul!(r, chol_lower(cholesky(a)), x)
    end
end
function invunwhiten!(r::AbstractVecOrMat, a::PDMat, x::AbstractVecOrMat)
    @check_argdims axes(r) == axes(x)
    @check_argdims a.dim == size(x, 1)
    if r === x
        return ldiv!(chol_upper(cholesky(a)), r)
    else
        return ldiv!(r, chol_upper(cholesky(a)), x)
    end
end

function whiten(a::PDMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return chol_lower(cholesky(a)) \ x
end
function invwhiten(a::PDMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return chol_upper(cholesky(a)) * x
end
function unwhiten(a::PDMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return chol_lower(cholesky(a)) * x
end
function invunwhiten(a::PDMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    return chol_upper(cholesky(a)) \ x
end

## quad/invquad

function quad(a::PDMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    aU_x = chol_upper(cholesky(a)) * x
    if x isa AbstractVector
        return sum(abs2, aU_x)
    else
        return vec(sum(abs2, aU_x; dims = 1))
    end
end

function quad!(r::AbstractArray, a::PDMat, x::AbstractMatrix)
    @check_argdims eachindex(r) == axes(x, 2)
    @check_argdims a.dim == size(x, 1)
    aU = chol_upper(cholesky(a))
    z = similar(r, a.dim) # buffer to save allocations
    @inbounds for i in axes(x, 2)
        mul!(z, aU, view(x, :, i))
        r[i] = sum(abs2, z)
    end
    return r
end

function invquad(a::PDMat, x::AbstractVecOrMat)
    @check_argdims a.dim == size(x, 1)
    inv_aL_x = chol_lower(cholesky(a)) \ x
    if x isa AbstractVector
        return sum(abs2, inv_aL_x)
    else
        return vec(sum(abs2, inv_aL_x; dims = 1))
    end
end

function invquad!(r::AbstractArray, a::PDMat, x::AbstractMatrix)
    @check_argdims eachindex(r) == axes(x, 2)
    @check_argdims a.dim == size(x, 1)
    aL = chol_lower(cholesky(a))
    z = similar(r, a.dim) # buffer to save allocations
    @inbounds for i in axes(x, 2)
        copyto!(z, view(x, :, i))
        ldiv!(aL, z)
        r[i] = sum(abs2, z)
    end
    return r
end

### tri products

function X_A_Xt(a::PDMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 2)
    z = x * chol_lower(a.chol)
    return Symmetric(z * transpose(z))
end

function Xt_A_X(a::PDMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 1)
    z = chol_upper(a.chol) * x
    return Symmetric(transpose(z) * z)
end

function X_invA_Xt(a::PDMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 2)
    z = x / chol_upper(a.chol)
    return Symmetric(z * transpose(z))
end

function Xt_invA_X(a::PDMat, x::AbstractMatrix{<:Real})
    @check_argdims a.dim == size(x, 1)
    z = chol_lower(a.chol) \ x
    return Symmetric(transpose(z) * z)
end

### Specializations for `Array` arguments with reduced allocations

function quad(a::PDMat{<:Real, <:Matrix}, x::Matrix)
    @check_argdims a.dim == size(x, 1)
    T = typeof(zero(eltype(a)) * abs2(zero(eltype(x))))
    return quad!(Vector{T}(undef, size(x, 2)), a, x)
end

function invquad(a::PDMat{<:Real, <:Matrix}, x::Matrix)
    @check_argdims a.dim == size(x, 1)
    T = typeof(abs2(zero(eltype(x))) / zero(eltype(a)))
    return invquad!(Vector{T}(undef, size(x, 2)), a, x)
end

# Useful utilities to support internal implementation


macro check_argdims(cond)
    return quote
        ($(esc(cond))) || throw(DimensionMismatch("Inconsistent argument dimensions."))
    end
end

function _addscal!(r::Matrix, a::Matrix, b::AbstractMatrix, c::Real)
    if isone(c)
        @. r = a + b
    else
        @. r = muladd(c, b, a)
    end
    return r
end

function _adddiag!(a::Union{Matrix, SparseMatrixCSC}, v::Real)
    for i in diagind(a)
        @inbounds a[i] += v
    end
    return a
end

function _adddiag!(a::Union{Matrix, SparseMatrixCSC}, v::AbstractVector, c::Real)
    @check_argdims eachindex(v) == axes(a, 1) == axes(a, 2)
    if c == one(c)
        for i in eachindex(v)
            @inbounds a[i, i] += v[i]
        end
    else
        for i in eachindex(v)
            @inbounds a[i, i] += v[i] * c
        end
    end
    return a
end

# Non-mutating diagonal addition: `a + diagonal` (optionally scaled by `c`). These
# work for dense, sparse, and immutable (e.g. static) matrices, and for dense
# matrices cost a single allocation just like the in-place path above (which is kept
# only for the truly in-place `pdadd!`).
_adddiag(a::AbstractMatrix, v::Real) = a + v * I

function _adddiag(a::AbstractMatrix, v::AbstractVector)
    @check_argdims eachindex(v) == axes(a, 1) == axes(a, 2)
    return a + Diagonal(v)
end

function _adddiag(a::AbstractMatrix, v::AbstractVector, c::Real)
    @check_argdims eachindex(v) == axes(a, 1) == axes(a, 2)
    return a .+ c .* Diagonal(v)
end

# As above, but the coefficient scales the matrix: `c * a + diagonal`. The scalar
# variant keeps an in-place fast path for mutable storage, since there is no clean
# single-allocation broadcast for adding a scalar to the diagonal only; other matrix
# types fall back to `muladd`, allowing fused implementations where available.
function _scaleadddiag(a::AbstractMatrix, c::Real, v::AbstractVector)
    @check_argdims eachindex(v) == axes(a, 1) == axes(a, 2)
    return c .* a .+ Diagonal(v)
end
_scaleadddiag(a::AbstractMatrix, c::Real, v::Real) = muladd(c, a, v * I)
_scaleadddiag(a::Union{Matrix, SparseMatrixCSC}, c::Real, v::Real) = _adddiag!(a * c, v)


function wsumsq(w::AbstractVector, a::AbstractVector)
    @check_argdims(eachindex(a) == eachindex(w))
    s = zero(promote_type(eltype(w), eltype(a)))
    for i in eachindex(w)
        @inbounds s += abs2(a[i]) * w[i]
    end
    return s
end

function invwsumsq(w::AbstractVector, a::AbstractVector)
    @check_argdims(eachindex(a) == eachindex(w))
    s = zero(zero(eltype(a)) / zero(eltype(w)))
    for i in eachindex(w)
        @inbounds s += abs2(a[i]) / w[i]
    end
    return s
end

function colwise_dot!(r::AbstractArray, a::AbstractMatrix, b::AbstractMatrix)
    @check_argdims(axes(a) == axes(b))
    @check_argdims(axes(a, 2) == eachindex(r))
    for j in axes(a, 2)
        v = zero(promote_type(eltype(a), eltype(b)))
        @simd for i in axes(a, 1)
            @inbounds v += a[i, j] * b[i, j]
        end
        r[j] = v
    end
    return r
end

function colwise_sumsq!(r::AbstractArray, a::AbstractMatrix, c::Real)
    @check_argdims(eachindex(r) == axes(a, 2))
    for j in axes(a, 2)
        v = zero(eltype(a))
        @simd for i in axes(a, 1)
            @inbounds v += abs2(a[i, j])
        end
        r[j] = v * c
    end
    return r
end

function colwise_sumsqinv!(r::AbstractArray, a::AbstractMatrix, c::Real)
    @check_argdims(eachindex(r) == axes(a, 2))
    for j in axes(a, 2)
        v = zero(eltype(a))
        @simd for i in axes(a, 1)
            @inbounds v += abs2(a[i, j])
        end
        r[j] = v / c
    end
    return r
end

using PDMats
using FiniteDifferences
using ForwardDiff

using LinearAlgebra
using Test

# issue #217
@testset "PDMat: (un)whiten" begin
    a = vec(Matrix{Float64}(I, 4, 4))
    fdm = central_fdm(5, 1)

    for (f, f!) in ((whiten, whiten!), (unwhiten, unwhiten!))
        apply_f = let f = f
            a -> f(PDMat(Symmetric(reshape(a, 4, 4))), ones(4))
        end
        apply_f! = let f! = f!
            a -> f!(Vector{promote_type(eltype(a), Float64)}(undef, 4), PDMat(Symmetric(reshape(a, 4, 4))), ones(4))
        end

        J = only(FiniteDifferences.jacobian(fdm, apply_f, a))
        @test only(FiniteDifferences.jacobian(fdm, apply_f!, a)) ≈ J

        @test ForwardDiff.jacobian(apply_f, a) ≈ J
        @test ForwardDiff.jacobian(apply_f!, a) ≈ J
    end
end

# issue #99: `invquad`/`quad` must differentiate correctly and allocate only
# O(n·#partials) — not O(n²·#partials), as when the factor was promoted to `Dual`.
@testset "PDMat: quad/invquad with ForwardDiff (issue #99)" begin
    n = 100
    M = randn(n, n)
    A = PDMat(Symmetric(M * M' + n * I))
    x = randn(n)

    # ∇ invquad(A, x) = 2 A⁻¹x, ∇ quad(A, x) = 2 A x
    for (f, grad) in ((invquad, 2 * (A \ x)), (quad, 2 * (A * x)))
        @test ForwardDiff.gradient(Base.Fix1(f, A), x) ≈ grad
    end

    # only a single result vector the size of `xd` is allocated, not an O(n²) matrix
    xd = [ForwardDiff.Dual(xi, Tuple(randn(4))) for xi in x]
    for f in (invquad, quad)
        g = Base.Fix1(f, A)
        g(xd)  # warm up
        @test (@allocated g(xd)) ≤ 3 * sizeof(xd)
    end
end

using PDMats
using Test
using LinearAlgebra: LinearAlgebra

function _pd_kron_compare(A::AbstractPDMat, B::AbstractPDMat)
    PDAkB_kron = @inferred kron(A, B)
    PDAkB_dense = PDMat(kron(Matrix(A), Matrix(B)))
    return _pd_compare(PDAkB_kron, PDAkB_dense)
end

n = 4
m = 7

@testset "Kronecker product" begin
    for T in [Float32, Float64]
        _pd_kron_compare(_randPDMat(T, n), _randPDMat(T, m))
        _pd_kron_compare(_randPDiagMat(T, n), _randPDiagMat(T, m))
        _pd_kron_compare(_randScalMat(T, n), _randScalMat(T, m))
        _pd_kron_compare(_randPDMat(T, n), _randPDiagMat(T, m))
        _pd_kron_compare(_randPDiagMat(T, m), _randPDMat(T, n))
        _pd_kron_compare(_randPDMat(T, n), _randScalMat(T, m))
        _pd_kron_compare(_randScalMat(T, m), _randPDMat(T, n))
        _pd_kron_compare(_randPDiagMat(T, n), _randScalMat(T, m))
        _pd_kron_compare(_randScalMat(T, m), _randPDiagMat(T, n))
    end
end
